#!/usr/bin/env python3
# -*- coding: utf-8 -*-

# Form implementation generated from reading ui file 'MainCoffee.ui'
#
# Created by: PyQt5 UI code generator 5.11.3
#
# WARNING! All changes made in this file will be lost!
from PyQt5 import QtCore, QtGui, QtWidgets
from PyQt5.QtCore import QTimer, Qt, QSize
import RPi.GPIO as GPIO
import time 
import requests
import os
import shutil
import json
import pyqrcode
from pyqrcode import QRCode
from io import BytesIO
import subprocess
from urllib.request import urlopen
import Api
import AutoUpdate
import pyspeedtest

def setRelay(pin):
    GPIO.setmode(GPIO.BCM)
    GPIO.setwarnings(False)
    GPIO.cleanup()
    GPIO.setup(pin, GPIO.OUT)
    GPIO.output(pin, GPIO.HIGH)
    
def setPin(pin1, pin2, pin3, pin4, pin5):
    GPIO.setmode(GPIO.BCM)
    GPIO.setwarnings(False)
    GPIO.cleanup()
    GPIO.setup(pin1, GPIO.OUT)
    GPIO.output(pin1, GPIO.HIGH)
    GPIO.setup(pin2, GPIO.OUT)
    GPIO.output(pin2, GPIO.HIGH)
    GPIO.setup(pin3, GPIO.OUT)
    GPIO.output(pin3, GPIO.HIGH)
    GPIO.setup(pin4, GPIO.OUT)
    GPIO.output(pin4, GPIO.HIGH)
    GPIO.setup(pin5, GPIO.OUT)
    GPIO.output(pin5, GPIO.HIGH)
    
def ConnectRelay(pin):
    GPIO.output(pin, GPIO.LOW)

def DisconnectRelay(pin):
    GPIO.output(pin, GPIO.HIGH)

def CheckFile(file):
    return os.path.isfile(file)

class Ui_Dialog(object):
    def setupUi(self, Dialog):
        Dialog.setObjectName("OmegaCoffee")
        Dialog.resize(1024, 600)
        Dialog.setWindowFlags(QtCore.Qt.FramelessWindowHint)
        Dialog.setWindowState(QtCore.Qt.WindowFullScreen)
        Dialog.setCursor(QtCore.Qt.BlankCursor)
        Dialog.setWindowIcon(QtGui.QIcon("/home/pi/Documents/OmegaCoffee/coffee.png"))
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Preferred, QtWidgets.QSizePolicy.Preferred)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(Dialog.sizePolicy().hasHeightForWidth())
        Dialog.setSizePolicy(sizePolicy)
        Dialog.setStyleSheet("background-color: rgb(0, 0, 0);")
        self.LogoBtn = QtWidgets.QPushButton(Dialog)
        self.LogoBtn.setGeometry(QtCore.QRect(0, 0, 275, 75))
        self.LogoBtn.setObjectName("LogoBtn")
        self.LogoBtn.clicked.connect(self.LogoClicked)
        self.LogoBtn.setStyleSheet("border-image: url(/home/pi/Documents/OmegaCoffee/Logo.png);")
        self.InternetBtn = QtWidgets.QPushButton(Dialog)
        self.InternetBtn.setGeometry(QtCore.QRect(950, 30, 30, 30))
        self.InternetBtn.setObjectName("InternetBtn")
        self.InternetBtn.setStyleSheet("QPushButton {background-color: red; color: white; border: none}")
        self.InternetBtn.clicked.connect(self.InternetBtnClicked)
        self.IsInternetClicked=False
        self.lblMainTitle = QtWidgets.QLabel(Dialog)
        self.lblMainTitle.setGeometry(QtCore.QRect(5, 75, 1014, 75))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(58)
        self.lblMainTitle.setFont(font)
        self.lblMainTitle.setText("")
        self.lblMainTitle.setStyleSheet("color: rgb(255, 255, 255);")
        self.lblMainTitle.setAlignment(QtCore.Qt.AlignCenter)
        self.lblMainTitle.setObjectName("lblMainTitle")
        self.lblMainTitle.show()
        self.lblVersion=QtWidgets.QLabel(Dialog)
        self.lblVersion.setGeometry(QtCore.QRect(280, 0, 50, 20))
        font = QtGui.QFont("Quicksand Medium")
        font.setPointSize(15)
        self.lblVersion.setFont(font)
        self.lblVersion.setText("V.")
        self.lblVersion.setStyleSheet("color: rgb(255, 255, 255);")
        self.lblVersion.setAlignment(QtCore.Qt.AlignCenter)
        self.lblVersion.setObjectName("lblVersion")
        self.lblVersion.show()
        self.lblInternetSpeed = QtWidgets.QLabel(Dialog)
        self.lblInternetSpeed.setGeometry(QtCore.QRect(865, 0, 100, 20))
        font = QtGui.QFont("Quicksand Medium")
        font.setPointSize(15)
        self.lblInternetSpeed.setFont(font)
        self.lblInternetSpeed.setText("..ms")
        self.lblInternetSpeed.setStyleSheet("color: rgb(255, 255, 255);")
        self.lblInternetSpeed.setAlignment(QtCore.Qt.AlignRight)
        self.lblInternetSpeed.setObjectName("lblInternetSpeed")
        self.lblInternetSpeed.hide()
        self.arrInternetSpeed=[]
        self.lblInternetPercent = QtWidgets.QLabel(Dialog)
        self.lblInternetPercent.setGeometry(QtCore.QRect(965, 0, 60, 20))
        font = QtGui.QFont("Quicksand Medium")
        font.setPointSize(15)
        self.lblInternetPercent.setFont(font)
        self.lblInternetPercent.setText("...%")
        self.lblInternetPercent.setStyleSheet("color: rgb(255, 255, 255);")
        self.lblInternetPercent.setAlignment(QtCore.Qt.AlignCenter)
        self.lblInternetPercent.setObjectName("lblInternetPercent")
        self.lblInternetPercent.show()
        self.lblMenuSelected = QtWidgets.QLabel(Dialog)
        self.lblMenuSelected.setGeometry(QtCore.QRect(5, 75, 1014, 40))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(30)
        self.lblMenuSelected.setFont(font)
        self.lblMenuSelected.setText("")
        self.lblMenuSelected.setStyleSheet("color: rgb(255, 255, 255);")
        self.lblMenuSelected.setAlignment(QtCore.Qt.AlignCenter)
        self.lblMenuSelected.setObjectName("lblMenuSelected")
        self.lblMenuSelected.hide()
        self.lblMenuPrice = QtWidgets.QLabel(Dialog)
        self.lblMenuPrice.setGeometry(QtCore.QRect(5, 125, 1014, 35))
        font = QtGui.QFont()
        font.setPointSize(30)
        self.lblMenuPrice.setFont(font)
        self.lblMenuPrice.setText("")
        self.lblMenuPrice.setStyleSheet("color: rgb(255, 255, 255);")
        self.lblMenuPrice.setAlignment(QtCore.Qt.AlignCenter)
        self.lblMenuPrice.setObjectName("lblMenuPrice")
        self.lblMenuPrice.hide()
        #frame Menu
        self.frameMenu = QtWidgets.QFrame(Dialog)
        self.frameMenu.setGeometry(QtCore.QRect(0, 160, 1024, 450))
        self.frameMenu.setStyleSheet("background-color: rgb(0, 0, 0);")
        self.frameMenu.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameMenu.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameMenu.setObjectName("frameMenu")
        self.Menu1Btn = QtWidgets.QPushButton(self.frameMenu)
        self.Menu1Btn.setGeometry(QtCore.QRect(200, 5, 824, 145))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(48)
        self.Menu1Btn.setFont(font)
        self.Menu1Btn.setStyleSheet("QPushButton {background-color: red; color: white; border: none}"
                                    "QPushButton:pressed {background-color: blue}")
        self.Menu1Btn.setObjectName("Menu1Btn")
        self.Menu1Btn.clicked.connect(self.MenuClick)
        self.Menu3Btn = QtWidgets.QPushButton(self.frameMenu)
        self.Menu3Btn.setGeometry(QtCore.QRect(200, 305, 824, 145))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(48)
        self.Menu3Btn.setFont(font)
        self.Menu3Btn.setStyleSheet("QPushButton {background-color: red; color: white; border: none}"
                                    "QPushButton:pressed {background-color: blue}")
        self.Menu3Btn.setObjectName("Menu3Btn")
        self.Menu3Btn.clicked.connect(self.Menu3Click)
        self.Menu2Btn = QtWidgets.QPushButton(self.frameMenu)
        self.Menu2Btn.setGeometry(QtCore.QRect(200, 155, 824, 145))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(48)
        self.Menu2Btn.setFont(font)
        self.Menu2Btn.setStyleSheet("QPushButton {background-color: red; color: white; border: none}"
                                    "QPushButton:pressed {background-color: blue}")
        self.Menu2Btn.setObjectName("Menu2Btn")
        self.Menu2Btn.clicked.connect(self.Menu2Click)
        self.lblQty = QtWidgets.QLabel(self.frameMenu)
        self.lblQty.setGeometry(QtCore.QRect(5, 155, 190, 145))
        font = QtGui.QFont()
        font.setPointSize(48)
        font.setBold(True)
        font.setWeight(75)
        self.lblQty.setFont(font)
        self.lblQty.setStyleSheet("background-color: rgb(255, 255, 255);")
        self.lblQty.setAlignment(QtCore.Qt.AlignCenter)
        self.lblQty.setObjectName("lblQty")
        self.AddQtyBtn = QtWidgets.QPushButton(self.frameMenu)
        self.AddQtyBtn.setGeometry(QtCore.QRect(5, 5, 190, 145))
        font = QtGui.QFont()
        font.setPointSize(36)
        self.AddQtyBtn.setFont(font)
        self.AddQtyBtn.setStyleSheet("background-color: rgb(255, 255, 255);")
        self.AddQtyBtn.setObjectName("AddQtyBtn")
        self.AddQtyBtn.clicked.connect(self.AddQtyClicked)
        self.DecQtyBtn = QtWidgets.QPushButton(self.frameMenu)
        self.DecQtyBtn.setGeometry(QtCore.QRect(5, 305, 190, 145))
        font = QtGui.QFont()
        font.setPointSize(36)
        self.DecQtyBtn.setFont(font)
        self.DecQtyBtn.setStyleSheet("background-color: rgb(255, 255, 255);")
        self.DecQtyBtn.setObjectName("DecQtyBtn")
        self.DecQtyBtn.clicked.connect(self.DecQtyClicked)
        #frame Login
        self.frameLogin = QtWidgets.QFrame(Dialog)
        tmpfont = QtGui.QFont()
        tmpfont.setFamily("Quicksand Medium")
        tmpfont.setPointSize(12)
        #self.frameLogin.setGeometry(QtCore.QRect(192, 0, 640, 220))
        self.frameLogin.setGeometry(QtCore.QRect(0, 0, 1024, 290))
        self.frameLogin.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameLogin.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameLogin.setObjectName("frameLogin")
        self.frameLogin.setStyleSheet("background-color: rgb(255, 255, 255);")
        self.frameLogin.hide()
        self.widget = QtWidgets.QWidget(self.frameLogin)
        #self.widget.setGeometry(QtCore.QRect(30, 30, 550, 111))
        self.widget.setGeometry(QtCore.QRect(222, 60, 550, 111))
        self.widget.setObjectName("widget")
        self.gridLayout = QtWidgets.QGridLayout(self.widget)
        self.gridLayout.setContentsMargins(0, 0, 0, 0)
        self.gridLayout.setObjectName("gridLayout")
        self.lblUserID = QtWidgets.QLabel(self.widget)
        self.lblUserID.setFont(tmpfont)
        self.lblUserID.setObjectName("lblUserID")
        self.gridLayout.addWidget(self.lblUserID, 0, 0, 1, 1)
        self.lineUserID = QtWidgets.QLineEdit(self.widget)
        self.lineUserID.setFont(tmpfont)
        self.lineUserID.setObjectName("lineUserID")
        self.lineUserID.returnPressed.connect(self.LoginClicked)
        self.gridLayout.addWidget(self.lineUserID, 0, 1, 1, 1)
        self.lblPassword = QtWidgets.QLabel(self.widget)
        self.lblPassword.setFont(tmpfont)
        self.lblPassword.setObjectName("lblPassword")
        self.gridLayout.addWidget(self.lblPassword, 1, 0, 1, 1)
        self.linePassword = QtWidgets.QLineEdit(self.widget)
        self.linePassword.setFont(tmpfont)
        self.linePassword.setObjectName("linePassword")
        self.linePassword.setEchoMode(QtWidgets.QLineEdit.Password)
        self.linePassword.returnPressed.connect(self.LoginClicked)
        self.gridLayout.addWidget(self.linePassword, 1, 1, 1, 1)
        self.widget1 = QtWidgets.QWidget(self.frameLogin)
        #self.widget1.setGeometry(QtCore.QRect(380, 180, 200, 25))
        self.widget1.setGeometry(QtCore.QRect(572, 210, 200, 30))
        self.widget1.setObjectName("widget1")
        self.gridLayout_2 = QtWidgets.QGridLayout(self.widget1)
        self.gridLayout_2.setContentsMargins(0, 0, 0, 0)
        self.gridLayout_2.setObjectName("gridLayout_2")
        self.CancelLoginBtn = QtWidgets.QPushButton(self.widget1)
        self.CancelLoginBtn.setFont(tmpfont)
        self.CancelLoginBtn.setObjectName("CancelLoginBtn")
        self.CancelLoginBtn.clicked.connect(self.LogoClicked)
        self.gridLayout_2.addWidget(self.CancelLoginBtn, 0, 0, 1, 1)
        self.LoginBtn = QtWidgets.QPushButton(self.widget1)
        self.LoginBtn.setFont(tmpfont)
        self.LoginBtn.setObjectName("LoginBtn")
        self.LoginBtn.clicked.connect(self.LoginClicked)        
        self.gridLayout_2.addWidget(self.LoginBtn, 0, 1, 1, 1)
        #frame Keyboard
        self.frameKeyboard = QtWidgets.QFrame(Dialog)
        #self.frameKeyboard.setGeometry(QtCore.QRect(87, 290, 850, 310))
        self.frameKeyboard.setGeometry(QtCore.QRect(0, 290, 1024, 310))
        self.frameKeyboard.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameKeyboard.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameKeyboard.setObjectName("frameKeyboard")
        self.frameKeyboard.setStyleSheet("background-color: rgb(255, 255, 255);")
        self.frameKeyboard.hide()
        self.buttons=["`", "1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "-", "=", "<-",
                 "Tab", "q", "w", "e", "r", "t", "y", "u", "i", "o", "p", "[", "]", "Ent",
                 "Caps", "a", "s", "d", "f", "g", "h", "j", "k", "l", ";", ":", "'", "Ctrl",
                 "Shft", "<", "z", "x", "c", "v", "b", "n", "m", ".", ",", "/", ">", "Alt",
                 "Space"]
        self.buttons2=["~", "!", "@", "#", "$", "%", "^", "&", "*", "(", ")", "_", "+", "<-",
                 "Tab", "Q", "W", "E", "R", "T", "Y", "U", "I", "O", "P", "{", "}", "Ent",
                 "Caps", "A", "S", "D", "F", "G", "H", "J", "K", "L", ";", ":", '"', "Ctrl",
                 "Shft", "<", "Z", "X", "C", "V", "B", "N", "M", ".", ",", "?", ">", "Alt",
                 "Space"]
        self.btn=[]
        for x in range(len(self.buttons)) :
            self.btn.append(x)
            self.btn[x]=QtWidgets.QPushButton(self.frameKeyboard)
            txtKey = self.buttons[x]
            self.btn[x].setText(txtKey)
            if txtKey=="Space":
                self.btn[x].setGeometry(QtCore.QRect(87+(x%14*60), 7+(x//14*60), 835, 55))            
            else :
                self.btn[x].setGeometry(QtCore.QRect(87+(x%14*60), 7+(x//14*60), 55, 55))
            self.btn[x].setFocusPolicy(QtCore.Qt.NoFocus)
            self.btn[x].clicked.connect(lambda checked, a=x : self.KeyboardClicked(a))
        self.CapsOn=False
        self.ShiftOn=False
        self.CtrlOn=False
        #frame Setting
        self.frameSetting = QtWidgets.QFrame(Dialog)
        self.frameSetting.setGeometry(QtCore.QRect(0, 0, 1024, 290))
        #self.frameSetting.setGeometry(QtCore.QRect(192, 0, 640, 290))
        self.frameSetting.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameSetting.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameSetting.setObjectName("frameSetting")
        self.frameSetting.setStyleSheet("background-color: rgb(255, 255, 255);")
        self.frameSetting.hide()
        self.widget2 = QtWidgets.QWidget(self.frameSetting)
        #self.widget2.setGeometry(QtCore.QRect(20, 21, 600, 141))
        self.widget2.setGeometry(QtCore.QRect(212, 21, 600, 141))
        self.widget2.setObjectName("widget2")
        self.gridLayout_3 = QtWidgets.QGridLayout(self.widget2)
        self.gridLayout_3.setContentsMargins(0, 0, 0, 0)
        self.gridLayout_3.setObjectName("gridLayout_3")
        self.lblStaff = QtWidgets.QLabel(self.widget2)
        self.lblStaff.setObjectName("lblStaff")
        self.gridLayout_3.addWidget(self.lblStaff, 0, 0, 1, 1)
        self.lineStaff = QtWidgets.QLineEdit(self.widget2)
        self.lineStaff.setObjectName("lineStaff")
        self.lineStaff.returnPressed.connect(self.SaveSettingClicked)
        self.gridLayout_3.addWidget(self.lineStaff, 0, 1, 1, 2)
        self.lblMenu1 = QtWidgets.QLabel(self.widget2)
        self.lblMenu1.setObjectName("lblMenu1")
        self.gridLayout_3.addWidget(self.lblMenu1, 1, 0, 1, 1)
        self.lineKode1 = QtWidgets.QLineEdit(self.widget2)
        self.lineKode1.setObjectName("lineKode1")
        self.lineKode1.returnPressed.connect(self.SaveSettingClicked)
        self.gridLayout_3.addWidget(self.lineKode1, 1, 1, 1, 1)
        self.lineCaption1 = QtWidgets.QLineEdit(self.widget2)
        self.lineCaption1.setObjectName("lineCaption1")
        self.lineCaption1.returnPressed.connect(self.SaveSettingClicked)
        self.gridLayout_3.addWidget(self.lineCaption1, 1, 2, 1, 1)
        self.lblMenu2 = QtWidgets.QLabel(self.widget2)
        self.lblMenu2.setObjectName("lblMenu2")
        self.gridLayout_3.addWidget(self.lblMenu2, 2, 0, 1, 1)
        self.lineKode2 = QtWidgets.QLineEdit(self.widget2)
        self.lineKode2.setObjectName("lineKode2")
        self.lineKode2.returnPressed.connect(self.SaveSettingClicked)
        self.gridLayout_3.addWidget(self.lineKode2, 2, 1, 1, 1)
        self.lineCaption2 = QtWidgets.QLineEdit(self.widget2)
        self.lineCaption2.setObjectName("lineCaption2")
        self.lineCaption2.returnPressed.connect(self.SaveSettingClicked)
        self.gridLayout_3.addWidget(self.lineCaption2, 2, 2, 1, 1)
        self.lblMenu3 = QtWidgets.QLabel(self.widget2)
        self.lblMenu3.setObjectName("lblMenu3")
        self.gridLayout_3.addWidget(self.lblMenu3, 3, 0, 1, 1)
        self.lineKode3 = QtWidgets.QLineEdit(self.widget2)
        self.lineKode3.setObjectName("lineKode3")
        self.lineKode3.returnPressed.connect(self.SaveSettingClicked)
        self.gridLayout_3.addWidget(self.lineKode3, 3, 1, 1, 1)
        self.lineCaption3 = QtWidgets.QLineEdit(self.widget2)
        self.lineCaption3.setObjectName("lineCaption3")
        self.lineCaption3.returnPressed.connect(self.SaveSettingClicked)
        self.gridLayout_3.addWidget(self.lineCaption3, 3, 2, 1, 1)
        self.widget3 = QtWidgets.QWidget(self.frameSetting)
        #self.widget3.setGeometry(QtCore.QRect(420, 260, 200, 21))
        self.widget3.setGeometry(QtCore.QRect(512, 255, 300, 30))
        self.widget3.setObjectName("widget3")
        self.gridLayout_4 = QtWidgets.QGridLayout(self.widget3)
        self.gridLayout_4.setContentsMargins(0, 0, 0, 0)
        self.gridLayout_4.setObjectName("gridLayout_4")
        self.ResetIngredientBtn = QtWidgets.QPushButton(self.widget3)
        self.ResetIngredientBtn.setObjectName("ResetIngredientBtn")
        self.ResetIngredientBtn.clicked.connect(self.IngredientSettingClicked)
        self.ResetIngredientBtn.hide()
        self.gridLayout_4.addWidget(self.ResetIngredientBtn, 0, 0, 1, 1)
        self.CancelSaveBtn = QtWidgets.QPushButton(self.widget3)
        self.CancelSaveBtn.setObjectName("CancelSaveBtn")
        self.CancelSaveBtn.clicked.connect(self.CancelSettingClicked)
        self.gridLayout_4.addWidget(self.CancelSaveBtn, 0, 1, 1, 1)
        self.SaveBtn = QtWidgets.QPushButton(self.widget3)
        self.SaveBtn.setObjectName("SaveBtn")
        self.SaveBtn.clicked.connect(self.SaveSettingClicked)
        self.gridLayout_4.addWidget(self.SaveBtn, 0, 2, 1, 1)
        self.DailyBtn = QtWidgets.QPushButton(self.frameSetting)
        #self.DailyBtn.setGeometry(QtCore.QRect(20, 205, 150, 50))
        self.DailyBtn.setGeometry(QtCore.QRect(212, 205, 150, 40))
        self.DailyBtn.setObjectName("DailyBtn")
        self.DailyBtn.clicked.connect(self.DailyClicked)
        self.DailyBtn.setStyleSheet("border-image: url(/home/pi/Documents/OmegaCoffee/Img/Daily.png);")
        self.WeeklyBtn = QtWidgets.QPushButton(self.frameSetting)
        #self.WeeklyBtn.setGeometry(QtCore.QRect(180, 205, 150, 50))
        self.WeeklyBtn.setGeometry(QtCore.QRect(372, 205, 150, 40))
        self.WeeklyBtn.setObjectName("WeeklyBtn")
        self.WeeklyBtn.clicked.connect(self.WeeklyClicked)
        self.WeeklyBtn.setStyleSheet("border-image: url(/home/pi/Documents/OmegaCoffee/Img/Weekly.png);")
        self.EmptyBtn = QtWidgets.QPushButton(self.frameSetting)
        #self.EmptyBtn.setGeometry(QtCore.QRect(340, 205, 150, 50))
        self.EmptyBtn.setGeometry(QtCore.QRect(532, 205, 150, 40))
        self.EmptyBtn.setObjectName("EmptyBtn")
        self.EmptyBtn.setStyleSheet("border-image: url(/home/pi/Documents/OmegaCoffee/Img/Empty.png);")
        self.DailyBtn.hide()
        self.WeeklyBtn.hide()
        self.EmptyBtn.hide()
        #self.GBTipePayment=QtWidgets.QGroupBox(self.frameSetting)
        self.widget4 = QtWidgets.QWidget(self.frameSetting)
        #self.widget4.setGeometry(QtCore.QRect(20, 170, 600, 30))
        self.widget4.setGeometry(QtCore.QRect(212, 170, 600, 30))
        self.widget4.setObjectName("widget4")
        self.gridLayoutGB = QtWidgets.QGridLayout(self.widget4)
        self.gridLayoutGB.setContentsMargins(0, 0, 0, 0)
        self.gridLayoutGB.setObjectName("gridLayoutGB")
        self.GBSingle=QtWidgets.QRadioButton(self.widget4)
        self.GBSingle.setText("Single Payment")
        self.gridLayoutGB.addWidget(self.GBSingle, 0, 0, 1, 1)
        self.GBMulti=QtWidgets.QRadioButton(self.widget4)
        self.GBMulti.setText("Multi Payment")
        self.gridLayoutGB.addWidget(self.GBMulti, 0, 1, 1, 1)
        #frame Ingredient Setting
        self.TmpWaterQty=10000
        self.TmpCupQty=60
        self.TmpM1Qty=1000
        self.TmpM2Qty=1000
        self.TmpM3Qty=1000
        self.frameIngredientSetting = QtWidgets.QFrame(Dialog)
        self.frameIngredientSetting.setGeometry(QtCore.QRect(0, 0, 1024, 600))
        self.frameIngredientSetting.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameIngredientSetting.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameIngredientSetting.setObjectName("frameIngredientSetting")
        self.frameIngredientSetting.setStyleSheet("background-color: rgb(255, 255, 255);")
        self.frameIngredientSetting.hide()
        self.BackToSettingBtn = QtWidgets.QPushButton(self.frameIngredientSetting)
        self.BackToSettingBtn.setGeometry(QtCore.QRect(5, 545, 50, 50))
        self.BackToSettingBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.BackToSettingBtn.setStyleSheet("QPushButton {background-color: red; color: white; border: none}"
                                    "QPushButton:pressed {background-color: blue}")
        self.BackToSettingBtn.setFont(tmpfont)
        self.BackToSettingBtn.setText("Back")
        self.BackToSettingBtn.clicked.connect(self.BackClicked)
        self.NextStepBtn2 = QtWidgets.QPushButton(self.frameIngredientSetting)
        self.NextStepBtn2.setGeometry(QtCore.QRect(0, 545, 1024, 50))
        self.NextStepBtn2.setFocusPolicy(QtCore.Qt.NoFocus)
        self.NextStepBtn2.setStyleSheet("QPushButton {background-color: red; color: white; border: none}"
                                    "QPushButton:pressed {background-color: blue}")
        self.NextStepBtn2.setFont(tmpfont)
        self.NextStepBtn2.setText("Update All and Next")
        self.NextStepBtn2.hide()
        self.NextStepBtn2.clicked.connect(self.NextStepBtn2Clicked)
        self.ResetWaterBtn = QtWidgets.QPushButton(self.frameIngredientSetting)
        self.ResetWaterBtn.setGeometry(QtCore.QRect(55, 90, 75, 75))
        self.ResetWaterBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.ResetWaterBtn.setFont(tmpfont)
        #self.ResetWaterBtn.setText("Water")
        self.ResetWaterBtn.setStyleSheet("border-image: url(/home/pi/Documents/OmegaCoffee/Img/ResetWater.png);")
        #self.ResetWaterBtn.clicked.connect()
        self.lineQtyWater = QtWidgets.QLineEdit(self.frameIngredientSetting)
        self.lineQtyWater.setObjectName("lineQtyWater")
        self.lineQtyWater.setGeometry(QtCore.QRect(150, 112, 200, 30))
        self.lineQtyWater.setFont(tmpfont)
        self.lineQtyWater.setText(str(self.TmpWaterQty))
        self.lblWaterUnit = QtWidgets.QLabel(self.frameIngredientSetting)
        self.lblWaterUnit.setObjectName("lblWaterUnit")
        self.lblWaterUnit.setGeometry(QtCore.QRect(360, 112, 30, 30))
        self.lblWaterUnit.setFont(tmpfont)
        self.lblWaterUnit.setText("ml")
        self.ResetCupBtn = QtWidgets.QPushButton(self.frameIngredientSetting)
        self.ResetCupBtn.setGeometry(QtCore.QRect(55, 180, 75, 75))
        self.ResetCupBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.ResetCupBtn.setFont(tmpfont)
        #self.ResetCupBtn.setText("Cup")
        self.ResetCupBtn.setStyleSheet("border-image: url(/home/pi/Documents/OmegaCoffee/Img/ResetCup.png);")
        #self.ResetCupBtn.clicked.connect()
        self.lineQtyCup = QtWidgets.QLineEdit(self.frameIngredientSetting)
        self.lineQtyCup.setObjectName("lineQtyCup")
        self.lineQtyCup.setGeometry(QtCore.QRect(150, 202, 200, 30))
        self.lineQtyCup.setFont(tmpfont)
        self.lineQtyCup.setText(str(self.TmpCupQty))
        self.lblCupUnit = QtWidgets.QLabel(self.frameIngredientSetting)
        self.lblCupUnit.setObjectName("lblCupUnit")
        self.lblCupUnit.setGeometry(QtCore.QRect(360, 202, 30, 30))
        self.lblCupUnit.setFont(tmpfont)
        self.lblCupUnit.setText("cup")
        self.ResetMenu1Btn = QtWidgets.QPushButton(self.frameIngredientSetting)
        self.ResetMenu1Btn.setGeometry(QtCore.QRect(55, 270, 75, 75))
        self.ResetMenu1Btn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.ResetMenu1Btn.setFont(tmpfont)
        #self.ResetMenu1Btn.setText("Menu1")
        self.ResetMenu1Btn.setStyleSheet("border-image: url(/home/pi/Documents/OmegaCoffee/Img/ResetM1.png);")
        #self.ResetMenu1Btn.clicked.connect()
        self.lineQtyMenu1 = QtWidgets.QLineEdit(self.frameIngredientSetting)
        self.lineQtyMenu1.setObjectName("lineQtyMenu1")
        self.lineQtyMenu1.setGeometry(QtCore.QRect(150, 292, 200, 30))
        self.lineQtyMenu1.setFont(tmpfont)
        self.lineQtyMenu1.setText(str(self.TmpM1Qty))
        self.lblMenu1Unit = QtWidgets.QLabel(self.frameIngredientSetting)
        self.lblMenu1Unit.setObjectName("lblMenu1Unit")
        self.lblMenu1Unit.setGeometry(QtCore.QRect(360, 292, 30, 30))
        self.lblMenu1Unit.setFont(tmpfont)
        self.lblMenu1Unit.setText("gr")
        self.ResetMenu2Btn = QtWidgets.QPushButton(self.frameIngredientSetting)
        self.ResetMenu2Btn.setGeometry(QtCore.QRect(55, 360, 75, 75))
        self.ResetMenu2Btn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.ResetMenu2Btn.setFont(tmpfont)
        #self.ResetMenu2Btn.setText("Menu2")
        self.ResetMenu2Btn.setStyleSheet("border-image: url(/home/pi/Documents/OmegaCoffee/Img/ResetM2.png);")
        #self.ResetMenu2Btn.clicked.connect()
        self.lineQtyMenu2 = QtWidgets.QLineEdit(self.frameIngredientSetting)
        self.lineQtyMenu2.setObjectName("lineQtyMenu2")
        self.lineQtyMenu2.setGeometry(QtCore.QRect(150, 382, 200, 30))
        self.lineQtyMenu2.setFont(tmpfont)
        self.lineQtyMenu2.setText(str(self.TmpM2Qty))
        self.lblMenu2Unit = QtWidgets.QLabel(self.frameIngredientSetting)
        self.lblMenu2Unit.setObjectName("lblMenu2Unit")
        self.lblMenu2Unit.setGeometry(QtCore.QRect(360, 382, 30, 30))
        self.lblMenu2Unit.setFont(tmpfont)
        self.lblMenu2Unit.setText("gr")
        self.ResetMenu3Btn = QtWidgets.QPushButton(self.frameIngredientSetting)
        self.ResetMenu3Btn.setGeometry(QtCore.QRect(55, 450, 75, 75))
        self.ResetMenu3Btn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.ResetMenu3Btn.setFont(tmpfont)
        #self.ResetMenu3Btn.setText("Menu3")
        self.ResetMenu3Btn.setStyleSheet("border-image: url(/home/pi/Documents/OmegaCoffee/Img/ResetM3.png);")
        #self.ResetMenu3Btn.clicked.connect()
        self.lineQtyMenu3 = QtWidgets.QLineEdit(self.frameIngredientSetting)
        self.lineQtyMenu3.setObjectName("lineQtyMenu3")
        self.lineQtyMenu3.setGeometry(QtCore.QRect(150, 472, 200, 30))
        self.lineQtyMenu3.setFont(tmpfont)
        self.lineQtyMenu3.setText(str(self.TmpM3Qty))
        self.lblMenu3Unit = QtWidgets.QLabel(self.frameIngredientSetting)
        self.lblMenu3Unit.setObjectName("lblMenu3Unit")
        self.lblMenu3Unit.setGeometry(QtCore.QRect(360, 472, 30, 30))
        self.lblMenu3Unit.setFont(tmpfont)
        self.lblMenu3Unit.setText("gr")
        self.widgetNumPad = QtWidgets.QWidget(self.frameIngredientSetting)
        self.widgetNumPad.setGeometry(QtCore.QRect(750, 145, 180, 330))
        self.widgetNumPad.setObjectName("widgetNumPad")
        self.gridLayoutNumPad = QtWidgets.QGridLayout(self.widgetNumPad)
        self.gridLayoutNumPad.setContentsMargins(0, 0, 0, 0)
        self.gridLayoutNumPad.setObjectName("gridLayoutNumPad")
        self.ArrNumPad=["7", "8", "9", "4", "5", "6", "1", "2", "3", "CE", "0", "C"]
        self.btnnum=[]
        for x in range(len(self.ArrNumPad)):
            self.btn.append(x)
            self.btn[x]=QtWidgets.QPushButton(self.frameIngredientSetting)
            txtKey = self.ArrNumPad[x]
            self.btn[x].setText(txtKey)
            self.btn[x].setFocusPolicy(QtCore.Qt.NoFocus)
            self.gridLayoutNumPad.addWidget(self.btn[x], x//3, x%3, 1, 1)
            self.btn[x].clicked.connect(lambda checked, a=x : self.NumPadClicked(a))    
        #line QR
        self.lineQR = QtWidgets.QLineEdit(Dialog)
        self.lineQR.setGeometry(QtCore.QRect(50, 610, 350, 23))
        self.lineQR.setObjectName("lineQR")
        self.lineQR.hide()
        #frame Payment        
        self.framePayment = QtWidgets.QFrame(Dialog)
        self.framePayment.setGeometry(QtCore.QRect(0, 160, 1024, 450))
        self.framePayment.setStyleSheet("background-color: rgb(0, 0, 0);")
        self.framePayment.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.framePayment.setFrameShadow(QtWidgets.QFrame.Raised)
        self.framePayment.setObjectName("framePayment")
        self.GoPayBtn = QtWidgets.QPushButton(self.framePayment)
        self.GoPayBtn.setGeometry(QtCore.QRect(0, 5, 1024, 145))
        #self.GoPayBtn.setGeometry(QtCore.QRect(0, 5, 1024, 105))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(48)
        self.GoPayBtn.setFont(font)
        self.GoPayBtn.setStyleSheet("QPushButton {background-color: red; color: white; border: none}"
                                    "QPushButton:pressed {background-color: blue}")
        self.GoPayBtn.setObjectName("GoPayBtn")
        self.GoPayBtn.clicked.connect(self.GoPayClicked)
        self.LinkAjaBtn = QtWidgets.QPushButton(self.framePayment)
        self.LinkAjaBtn.setGeometry(QtCore.QRect(0, 155, 1024, 145))
        #self.LinkAjaBtn.setGeometry(QtCore.QRect(0, 115, 1024, 105))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(48)
        self.LinkAjaBtn.setFont(font)
        self.LinkAjaBtn.setStyleSheet("QPushButton {background-color: red; color: white; border: none}"
                                      "QPushButton:pressed {background-color: blue}")
        self.LinkAjaBtn.setObjectName("LinkAjaBtn")
        self.LinkAjaBtn.clicked.connect(self.LinkAjaClicked)        
        self.ShopeeBtn = QtWidgets.QPushButton(self.framePayment)
        self.ShopeeBtn.setGeometry(QtCore.QRect(0, 225, 1024, 105))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(48)
        self.ShopeeBtn.setFont(font)
        self.ShopeeBtn.setStyleSheet("QPushButton {background-color: red; color: white; border: none}"
                                         "QPushButton:pressed {background-color: blue}")
        self.ShopeeBtn.setObjectName("ShopeeBtn")
        self.ShopeeBtn.clicked.connect(self.ShopeeClicked)
        self.LaundroMatBtn = QtWidgets.QPushButton(self.framePayment)
        self.LaundroMatBtn.setGeometry(QtCore.QRect(0, 335, 1024, 105))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(48)
        self.LaundroMatBtn.setFont(font)
        self.LaundroMatBtn.setStyleSheet("QPushButton {background-color: red; color: white; border: none}"
                                         "QPushButton:pressed {background-color: blue}")
        self.LaundroMatBtn.setObjectName("LaundroMatBtn")
        self.LaundroMatBtn.clicked.connect(self.LaundroMatClicked)
        self.CancelPaymentBtn = QtWidgets.QPushButton(self.framePayment)
        self.CancelPaymentBtn.setGeometry(QtCore.QRect(0, 305, 1024, 145))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setFamily("Sans Serif")
        font.setPointSize(28)
        self.CancelPaymentBtn.setFont(font)
        self.CancelPaymentBtn.setStyleSheet("QPushButton {background-color: red; color: white; border: none}"
                                            "QPushButton:pressed {background-color: blue}")
        self.CancelPaymentBtn.setObjectName("CancelPaymentBtn")
        self.CancelPaymentBtn.clicked.connect(self.CancelPayment)
        self.framePayment.hide()        
        #frame Payment test   
        self.framePayment2 = QtWidgets.QFrame(Dialog)
        self.framePayment2.setGeometry(QtCore.QRect(0, 160, 1024, 450))
        self.framePayment2.setStyleSheet("background-color: rgb(0, 0, 0);")
        self.framePayment2.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.framePayment2.setFrameShadow(QtWidgets.QFrame.Raised)
        self.framePayment2.setObjectName("framePayment2")
        self.CancelPaymentBtn2 = QtWidgets.QPushButton(self.framePayment2)
        self.CancelPaymentBtn2.setGeometry(QtCore.QRect(2, 302, 1020, 146))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setFamily("Sans Serif")
        font.setPointSize(28)
        self.CancelPaymentBtn2.setFont(font)
        self.CancelPaymentBtn2.setStyleSheet("QPushButton {background-color: red; color: white; border: none}"
                                            "QPushButton:pressed {background-color: blue}")
        self.CancelPaymentBtn2.setObjectName("CancelPaymentBtn2")
        self.CancelPaymentBtn2.clicked.connect(self.CancelPayment)
        self.btnPay=[]
        for y in range(6):
            self.btnPay.append(y)
            self.btnPay[y]=QtWidgets.QPushButton(self.framePayment2)
            font = QtGui.QFont()
            font.setFamily("Quicksand Medium")
            font.setPointSize(48)
            self.btnPay[y].setFont(font)
            self.btnPay[y].setStyleSheet("QPushButton {background-color: red; color: white; border: none}"
                                        "QPushButton:pressed {background-color: blue}")
            self.btnPay[y].setText(str(y))
            self.btnPay[y].setGeometry(QtCore.QRect((2+y//3*512), (2+y%3*100), 508, 106))
            #self.btnPay[y].setFocusPolicy(QtCore.Qt.NoFocus)
            self.btnPay[y].clicked.connect(lambda checked, a=y : self.ModePayClicked(a))
        self.ModePay=[]
        self.framePayment2.hide()
        #frame SinglePayment        
        self.frameSinglePayment = QtWidgets.QFrame(Dialog)
        self.frameSinglePayment.setGeometry(QtCore.QRect(0, 160, 1024, 440))
        self.frameSinglePayment.setStyleSheet("background-color: rgb(0, 0, 0);")
        self.frameSinglePayment.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameSinglePayment.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameSinglePayment.setObjectName("frameSinglePayment")
        #self.lblBG = QtWidgets.QLabel(self.frameSinglePayment)
        #self.lblBG.setGeometry(QtCore.QRect(0,0,1024,440))
        #self.lblBG.setStyleSheet("border-image: url(/home/pi/Documents/OmegaCoffee/TestBG.jpeg);")
        self.webSingleQR = QtWebKitWidgets.QWebView(self.frameSinglePayment)
        self.webSingleQR.setGeometry(QtCore.QRect(347, 0, 330, 330))
        self.webSingleQR.setUrl(QtCore.QUrl("http://www.google.com/"))
        self.webSingleQR.setObjectName("webSingleQR")
        self.CancelSinglePaymentBtn = QtWidgets.QPushButton(self.frameSinglePayment)
        self.CancelSinglePaymentBtn.setGeometry(QtCore.QRect(0, 310, 1024, 135))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setFamily("Sans Serif")
        font.setPointSize(28)
        self.CancelSinglePaymentBtn.setFont(font)
        self.CancelSinglePaymentBtn.setStyleSheet("QPushButton {background-color: red; color: white; border: none}"
                                            "QPushButton:pressed {background-color: blue}")
        self.CancelSinglePaymentBtn.setObjectName("CancelSinglePaymentBtn")
        self.CancelSinglePaymentBtn.clicked.connect(self.CancelPayment)
        self.frameSinglePayment.hide()
        #webView QR
        self.webView = QtWebKitWidgets.QWebView(Dialog)
        self.webView.setGeometry(QtCore.QRect(0, 160, 1024, 310))
        self.webView.setUrl(QtCore.QUrl("http://www.google.com/"))
        self.webView.setObjectName("webView")
        self.webView.hide()
        #frame Help
        self.StepCount=1
        self.HelpSelected=""
        self.WebStepSelected=[]
        self.WebStepDaily=["http://www.google.com/", "http://www.kaskus.co.id/"]
        self.WebStepWeekly=["http://www.google.com/", "http://www.kaskus.co.id/", "http://www.google.com/"]
        self.frameHelp = QtWidgets.QFrame(Dialog)
        self.frameHelp.setGeometry(QtCore.QRect(0, 0, 1024, 610))
        self.frameHelp.setStyleSheet("background-color: rgb(0,0,0);")
        self.frameHelp.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameHelp.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameHelp.setObjectName("frameHelp")
        self.lblStep = QtWidgets.QLabel(self.frameHelp)
        self.lblStep.setGeometry(QtCore.QRect(0, 5, 1024, 30))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(25)
        self.lblStep.setFont(font)
        self.lblStep.setStyleSheet("color: rgb(255, 255, 255);")
        self.lblStep.setAlignment(QtCore.Qt.AlignCenter)
        self.lblStep.setObjectName("lblStep")
        self.lblTimerCD = QtWidgets.QLabel(self.frameHelp)
        self.lblTimerCD.setGeometry(QtCore.QRect(0, 40, 1024, 500))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(40)
        self.lblTimerCD.setFont(font)
        self.lblTimerCD.setStyleSheet("color: rgb(255, 255, 255);")
        self.lblTimerCD.setAlignment(QtCore.Qt.AlignCenter)
        self.lblTimerCD.setObjectName("lblTimerCD")
        self.lblTimerCD.hide()
        self.webHelp = QtWebKitWidgets.QWebView(self.frameHelp)
        self.webHelp.setGeometry(QtCore.QRect(0, 40, 1024, 500))
        #self.webHelp.setUrl(QtCore.QUrl("http://www.google.com/"))
        self.webHelp.setObjectName("webHelp")
        self.NextHelpBtn = QtWidgets.QPushButton(self.frameHelp)
        self.NextHelpBtn.setGeometry(QtCore.QRect(5, 545, 1014, 50))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(25)
        self.NextHelpBtn.setFont(font)
        self.NextHelpBtn.setStyleSheet("QPushButton {background-color: red; color: white; border: none}"
                                         "QPushButton:pressed {background-color: blue}")
        self.NextHelpBtn.setObjectName("NextHelpBtn")
        self.NextHelpBtn.clicked.connect(self.NextHelpClicked)     
        self.frameHelp.hide()
        #frame Information
        self.frameInformation = QtWidgets.QFrame(Dialog)
        self.frameInformation.setGeometry(QtCore.QRect(0, 160, 1024, 450))
        self.frameInformation.setStyleSheet("background-color: rgb(0, 0, 0);")
        self.frameInformation.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameInformation.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameInformation.setObjectName("frameInformation")
        self.lblInformation = QtWidgets.QLabel(self.frameInformation)
        self.lblInformation.setGeometry(QtCore.QRect(5, 0, 1014, 300))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(30)
        self.lblInformation.setFont(font)
        self.lblInformation.setStyleSheet("color: rgb(255, 255, 255);")
        self.lblInformation.setAlignment(QtCore.Qt.AlignCenter)
        self.lblInformation.setObjectName("lblInformation")
        self.BackToMainBtn = QtWidgets.QPushButton(self.frameInformation)
        self.BackToMainBtn.setGeometry(QtCore.QRect(5, 305, 1024, 145))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(28)
        self.BackToMainBtn.setFont(font)
        self.BackToMainBtn.setStyleSheet("QPushButton {background-color: red; color: white; border: none}"
                                         "QPushButton:pressed {background-color: blue}")
        self.BackToMainBtn.setObjectName("BackToMainBtn")
        self.BackToMainBtn.clicked.connect(self.CancelPayment)
        self.frameInformation.hide()
        #frameInformation2
        self.frameInformation2 = QtWidgets.QFrame(Dialog)
        self.frameInformation2.setGeometry(QtCore.QRect(0, 160, 1024, 450))
        self.frameInformation2.setStyleSheet("background-color: rgb(0, 0, 0);")
        self.frameInformation2.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameInformation2.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameInformation2.setObjectName("frameInformation2")
        self.lblInformation2 = QtWidgets.QLabel(self.frameInformation2)
        self.lblInformation2.setGeometry(QtCore.QRect(5, 5, 1014, 300))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(30)
        self.lblInformation2.setFont(font)
        self.lblInformation2.setStyleSheet("color: rgb(255, 255, 255);")
        self.lblInformation2.setAlignment(QtCore.Qt.AlignCenter)
        self.lblInformation2.setObjectName("lblInformation2")
        self.NextCupBtn = QtWidgets.QPushButton(self.frameInformation2)
        self.NextCupBtn.setGeometry(QtCore.QRect(5, 305, 1024, 145))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(28)
        self.NextCupBtn.setFont(font)
        self.NextCupBtn.setStyleSheet("QPushButton {background-color: red; color: white; border: none}"
                                      "QPushButton:pressed {background-color: blue}")
        self.NextCupBtn.setObjectName("NextCupBtn")
        self.NextCupBtn.clicked.connect(self.NextCupClicked)
        self.frameInformation2.hide()
        #frameProgress
        self.frameProgress = QtWidgets.QFrame(Dialog)
        self.frameProgress.setGeometry(QtCore.QRect(0, 160, 1024, 450))
        self.frameProgress.setStyleSheet("background-color: rgb(0, 0, 0);")
        self.frameProgress.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameProgress.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameProgress.setObjectName("frameProgress")
        self.lblInfoProgress = QtWidgets.QLabel(self.frameProgress)
        self.lblInfoProgress.setGeometry(QtCore.QRect(5, 5, 1014, 300))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(24)
        self.lblInfoProgress.setFont(font)
        self.lblInfoProgress.setStyleSheet("color: rgb(255, 255, 255);")
        self.lblInfoProgress.setAlignment(QtCore.Qt.AlignCenter)
        self.lblInfoProgress.setObjectName("lblInformation2")
        self.ProgressBackBtn = QtWidgets.QPushButton(self.frameProgress)
        self.ProgressBackBtn.setGeometry(QtCore.QRect(5, 305, 1024, 145))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(28)
        self.ProgressBackBtn.setFont(font)
        self.ProgressBackBtn.setStyleSheet("QPushButton {background-color: red; color: white; border: none}"
                                           "QPushButton:pressed {background-color: blue}")
        self.ProgressBackBtn.setObjectName("NextCupBtn")
        self.ProgressBackBtn.clicked.connect(self.CancelPayment)
        self.ProgressBackBtn.hide()
        self.frameProgress.hide()
        #frame QR
        self.frameQR = QtWidgets.QFrame(Dialog)
        self.frameQR.setGeometry(QtCore.QRect(0, 160, 1024, 300))
        self.frameQR.setStyleSheet("background-color: rgb(255, 255, 255);")
        self.frameQR.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameQR.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameQR.setObjectName("frameQR")
        self.lblQR = QtWidgets.QLabel(self.frameQR)
        self.lblQR.setGeometry(QtCore.QRect(440, 10, 400, 400))
        self.lblQR.setText("")
        self.lblQR.setObjectName("lblQR")
        #self.lblQR.setStyleSheet("background-color: black")
        self.frameQR.hide()
        
        self.channel1=6 #26
        self.channel2=13 #19
        self.channel3=19 #13
        self.channel4=26 #6
        self.channel5=18
        setPin(self.channel1, self.channel2, self.channel3, self.channel4, self.channel5)
        self.i=0
        self.j=0
        self.TimerPay=QTimer()
        self.TimerPay.setInterval(1000)
        self.TimerPay.timeout.connect(self.TimerPayOn)
        self.TimerStatus=QTimer()
        self.TimerStatus.setInterval(5)
        self.TimerStatus.timeout.connect(self.TimerStatusOn)
        #self.TimerStatus.timeout.connect(self.TinerStatus2)
        self.k=0
        self.TimerInternet=QTimer()
        self.TimerInternet.setInterval(1000)
        self.TimerInternet.timeout.connect(self.TimerInternetOn)
        self.TimerInternet.start()
        self.l=0
        self.TimerProgress=QTimer()
        self.TimerProgress.setInterval(250)
        self.TimerProgress.timeout.connect(self.TimerProgressOn)
        self.m=600
        self.TimerCD=QTimer()
        self.TimerCD.setInterval(1000)
        self.TimerCD.timeout.connect(self.TimerCDOn)
        self.o=0
        self.TimerAutoBack=QTimer()
        self.TimerAutoBack.setInterval(1000)
        self.TimerAutoBack.timeout.connect(self.TimerAutoBackOn)
        
        self.MenuSelected=""
        self.TrxID=""
        self.OrderQty=1
        self.lblQty.setText(str(self.OrderQty))
        
        self.UserID = "admin"
        self.Password = "omega"
        
        self.src_dir=os.curdir
        #self.fileSetting=os.path.join(self.src_dir, "Setting.txt")
        #self.fileSettingBackup=os.path.join(self.src_dir, "SettingBackup.txt")
        self.fileSetting="/home/pi/Documents/OmegaCoffee/Setting.txt"
        self.fileSettingBackup="/home/pi/Documents/OmegaCoffee/SettingBackup.txt"
        #self.fileExist=CheckFile("/home/pi/Documents/OmegaCoffee/Setting.txt")
        self.fileExist=CheckFile(self.fileSetting)
        self.fileBackupExist=CheckFile(self.fileSettingBackup)
        self.TypePay=""
        if self.fileBackupExist :
            if self.fileExist==False :
                shutil.copy(self.fileSettingBackup, self.fileSetting)
                self.fileExist=CheckFile(self.fileSetting)
        #self.fileExist=CheckFile(self.fileSetting)
        if self.fileExist :
            #with open("/home/pi/Documents/OmegaCoffee/Setting.txt") as search:
            with open(self.fileSetting) as search:
                for line in search:
                    line=line.rstrip()
                    if "Staff" in line :
                        self.Staff=line.replace("Staff : ", "")
                    elif "Kode1" in line :
                        self.Kode1=line.replace("Kode1 : ", "")
                    elif "Caption1" in line :
                        self.Caption1=line.replace("Caption1 : ", "")
                    elif "Kode2" in line :
                        self.Kode2=line.replace("Kode2 : ", "")
                    elif "Caption2" in line :
                        self.Caption2=line.replace("Caption2 : ", "")
                    elif "Kode3" in line :
                        self.Kode3=line.replace("Kode3 : ", "")
                    elif "Caption3" in line :
                        self.Caption3=line.replace("Caption3 : ", "")
                    elif "TypePay" in line :
                        self.TypePay=line.replace("TypePay : ", "")
        else :            
            self.Staff = ""
            self.Kode1 = ""
            self.Kode2 = ""
            self.Kode3 = ""
            self.Caption1 = "Menu 1"
            self.Caption2 = "Menu 2"
            self.Caption3 = "Menu 3"
            self.TypePay = "Multi"
        
        self.fileVersi="/home/pi/Documents/OmegaCoffee/Versi.txt"
        self.Versi=""
        if CheckFile(self.fileVersi):
            with open(self.fileVersi) as search:
                for line in search:
                    line=line.rstrip()
                    if "Versi" in line :
                        self.Versi=line.replace("Versi=", "")
        else :
            self.Versi="Unknown"            
        self.lblVersion.setText("V."+self.Versi)
        
        self.payCancel=False
        self.tryCancel=0
        self.z=0
        self.LaundroMatBtn.hide()
        self.GoPayBtn.hide()
        self.LinkAjaBtn.hide()
        self.ShopeeBtn.hide()
        self.getPaymentMode=False
        self.ModePay.clear()
        self.IsSingleQR=False
        while True:
            hasiltipe=Api.CekTipePayment(self.Staff)
            #print("Hasil tipe : "+hasiltipe)
            if "Terjadi Kesalahan" in hasiltipe:
                if self.z>5:
                    break
            else :
                if ("Gopay" in hasiltipe) or ("LinkAja" in hasiltipe) or ("Shopee" in hasiltipe) :
                    if "GoPay" in hasiltipe:
                        self.GoPayBtn.show()
                        self.ModePay.append("GoPay")
                    if "LinkAja" in hasiltipe:
                        self.LinkAjaBtn.show()
                        self.ModePay.append("LinkAja")
                    if "Shopee" in hasiltipe:
                        #self.ShopeeBtn.show()
                        self.ModePay.append("Shopee")
                        self.IsSingleQR=True
                    self.getPaymentMode=True
                self.RedrawPayment()
                break            
            self.z+=1
        #print(self.ModePay)

        self.retranslateUi(Dialog)
        QtCore.QMetaObject.connectSlotsByName(Dialog)
        
    def InternetBtnClicked(self):
        vis = self.frameLogin.isVisible()
        if vis:
            self.frameLogin.hide()
            self.lineUserID.setText("")
            self.linePassword.setText("")
            self.frameKeyboard.hide()
            if self.IsInternetClicked==True:
                self.IsInternetClicked=False    
        else :
            self.IsInternetClicked=True
            self.frameLogin.show()
            self.lineUserID.setFocus()
            self.frameKeyboard.show()
            self.frameLogin.raise_()
            self.frameKeyboard.raise_()
        #Dialog.showMinimized()
        
    def TimerInternetOn(self):
        #print(self.k)
        hostname="www.telkom.co.id"
        if self.k%60==0:
            speedtest = pyspeedtest.SpeedTest(hostname)
            try :
                ping = speedtest.ping()
                ping = int(ping)
                checkinternet=True
            except :
                ping = 10000
                checkinternet=False
            print("ping "+str(ping))
            #if ping == 0 :
                #ping = 10000
                #checkinternet=False
            #else :
                #checkinternet=True
            #print(response)
            print(checkinternet)
            if checkinternet==True:            
                self.InternetBtn.setStyleSheet("QPushButton {background-color: green; color: white; border: none}")
            else :
                self.InternetBtn.setStyleSheet("QPushButton {background-color: red; color: white; border: none}")
            
            self.lblInternetSpeed.setText(str(ping)+" ms")
            if ping <=50:
                strRange="100%"
            elif ping >50 and ping <=100:
                strRange="75%"
            elif ping >100 and ping <=200:
                strRange="50%"
            elif ping >200 and ping <=300:
                strRange="25%"
            elif ping >300 :
                strRange="0%"
            self.lblInternetPercent.setText(strRange)
            #if len(self.arrInternetSpeed)<4:
                #self.arrInternetSpeed.append(ping)
            #elif len(self.arrInternetSpeed)==4:
                #range = int(sum(self.arrInternetSpeed)/4)
                #if range <= 50 :
                    #strRange = "100%"
                #elif range <=100 and range > 50 :
                    #strRange = "75%"
                #elif range <=200 and range > 100 :
                    #strRange = "50%"
                #elif range > 200 and range <=500:
                    #strRange = "25%"
                #elif range > 500 :
                    #strRange = "0%"
                #self.lblInternetPercent.setText(strRange)
                #self.arrInternetSpeed.clear()
        #if self.k%30==0:
            #response=os.system("ping -c 1 "+hostname)
            #if response==0:
                #checkinternet=True
            #else :
                #checkinternet=False
            #print(response)
            #print(checkinternet)
            #if checkinternet==True:            
                #self.InternetBtn.setStyleSheet("QPushButton {background-color: green; color: white; border: none}")
            #else :
                #self.InternetBtn.setStyleSheet("QPushButton {background-color: red; color: white; border: none}")            
        self.k+=1
    
    def TimerProgressOn(self):
        if self.l==0 :
            if self.frameMenu.isVisible() :
                #self.MenuSelected=self.Kode1
                self.frameMenu.hide()
                self.lblMainTitle.hide()
                print(self.MenuSelected)
                if self.MenuSelected==self.Kode1 :
                    txtCaption=self.Caption1
                elif self.MenuSelected==self.Kode2 :
                    txtCaption=self.Caption2
                elif self.MenuSelected==self.Kode3 :
                    txtCaption=self.Caption3
                if len(txtCaption)>15 :
                    self.lblMenuSelected.setText(str(self.OrderQty)+" cup "+txtCaption[:15]+"...")
                else :
                    self.lblMenuSelected.setText(str(self.OrderQty)+" cup "+txtCaption)
                if self.TypePay=="Multi":
                    txtLabel1="Mengambil Mode Pembayaran."
                    txtLabel2="Mohon tunggu.."
                elif self.TypePay=="Single":               
                    txtLabel1="Mengambil Kode QR."
                    txtLabel2="Mohon tunggu.."
                    self.PaySelected="Shopee"
                self.lblInfoProgress.setText("<span style='font-size:30pt'>"+txtLabel1+"</span><br><span style='font-size:50pt'>"+txtLabel2+"</span>")
                #self.lblInfoProgress.setText("Mengambil Mode Pembayaran.\nMohon Tunggu..")
                self.frameProgress.show()
                #print(self.PaySelected)
            #elif self.framePayment.isVisible():
            elif self.framePayment2.isVisible():                 
                txtLabel1="Mengambil Kode QR."
                txtLabel2="Mohon tunggu.."
                self.lblInfoProgress.setText("<span style='font-size:30pt'>"+txtLabel1+"</span><br><span style='font-size:50pt'>"+txtLabel2+"</span>")
                #self.lblInfoProgress.setText("Mengambil Kode QR.\nMohon Tunggu..")
                self.frameProgress.show()
                print(self.PaySelected)
            #elif self.webview.isVisibel():                 
                #txtLabel1="Membatalkan Pembelian."
                #txtLabel2="Mohon tunggu.."
                #self.lblInfoProgress.setText("<span style='font-size:30pt'>"+txtLabel1+"</span><br><span style='font-size:50pt'>"+txtLabel2+"</span>")
                #self.lblInfoProgress.setText("Mengambil Kode QR.\nMohon Tunggu..")
                #self.frameProgress.show()
                #print(self.Trxid)
        elif self.l==1 :                
            if "Mengambil Mode Pembayaran" in self.lblInfoProgress.text():
                self.CekStoknStaff()
                self.TimerProgress.stop()
            elif "Mengambil Kode QR" in self.lblInfoProgress.text() :
                if self.TypePay=="Multi":
                    self.TrxId, urlqr = Api.CreatePayment(self.Staff, self.MenuSelected, self.OrderQty, self.PaySelected)
                    print("TrxId : "+self.TrxId + " , url : "+ urlqr)
                    if self.TrxId == "Terjadi Kesalahan" and urlqr == "Terjadi Kesalahan":
                        self.frameProgress.hide()
                        self.lblInformation.setText("Terjadi kesalahan.\nSilahkan coba lagi")
                        self.frameInformation.show()    
                    else :
                        self.frameProgress.hide()
                        self.webView.setUrl(QtCore.QUrl(urlqr))
                        self.webView.show()
                        self.webView.raise_()
                        cursor=QtGui.QCursor()
                        print(cursor.pos())
                        cursor.setPos(0,0)
                        self.i=0
                        self.payCancel=False
                        self.TimerPay.start()
                elif self.TypePay=="Single":
                    self.CekStoknStaff()
        elif self.l > 2 :
            self.TimerProgress.stop()
        self.l+=1
        
    def NumPadClicked(self, index):
        widgetname=QtWidgets.QApplication.focusWidget().objectName()
        linetext=QtWidgets.QApplication.focusWidget()
        if widgetname=="lineQtyWater" or widgetname=="lineQtyCup" or widgetname=="lineQtyMenu1" or widgetname=="lineQtyMenu2" or widgetname=="lineQtyMenu3":
            numkey=self.ArrNumPad[index]
            if numkey=="CE":
                linetext.clear()
            elif numkey=="C":
                linetext.backspace()
            else:
                linetext.setText(linetext.text()+self.ArrNumPad[index])
            
    def KeyboardClicked(self, index):
        widgetname=QtWidgets.QApplication.focusWidget().objectName()
        linetext=QtWidgets.QApplication.focusWidget()
        if widgetname=="lineUserID" or widgetname=="linePassword" or widgetname=="lineStaff" or widgetname=="lineKode1" or widgetname=="lineKode2" or widgetname=="lineKode3" or widgetname=="lineCaption1" or widgetname=="lineCaption2" or widgetname=="lineCaption3":
            if self.CapsOn==True :
                keyboard=self.buttons2[index]
            else :
                keyboard=self.buttons[index]
            if keyboard=="Space":
                linetext.setText(linetext.text()+" ")
            elif keyboard=="Ent":
                #print("press Enter")
                if widgetname=="lineUserID" or widgetname=="linePassword":
                    self.LoginClicked()
                elif widgetname=="lineStaff" or widgetname=="lineKode1" or widgetname=="lineKode2" or widgetname=="lineKode3" or widgetname=="lineCaption1" or widgetname=="lineCaption2" or widgetname=="lineCaption3":
                    self.SaveSettingClicked()                
            elif keyboard=="Alt":
                print("press Alt")
            elif keyboard=="Ctrl":
                #print("press Ctrl")
                self.CtrlOn= not self.CtrlOn
            elif keyboard=="Shft":
                #print("press Shft")
                self.ShiftOn = not self.ShiftOn
                self.CapsOn = not self.CapsOn
                self.RedrawKeyboard()
            elif keyboard=="Tab":
                #print("press Tab")
                if widgetname=="lineUserID":
                    self.linePassword.setFocus()
                elif widgetname=="linePassword":
                    self.lineUserID.setFocus()
                elif widgetname=="lineStaff":
                    self.lineKode1.setFocus()
                elif widgetname=="lineKode1":
                    self.lineCaption1.setFocus()
                elif widgetname=="lineCaption1":
                    self.lineKode2.setFocus()
                elif widgetname=="lineKode2":
                    self.lineCaption2.setFocus()
                elif widgetname=="lineCaption2":
                    self.lineKode3.setFocus()
                elif widgetname=="lineKode3":
                    self.lineCaption3.setFocus()
                elif widgetname=="lineCaption3":
                    self.lineStaff.setFocus()
            elif keyboard=="Caps":
                #print("press Caps")
                self.CapsOn = not self.CapsOn
                self.RedrawKeyboard()
            elif keyboard=="<-":
                linetext.backspace()
            else :
                if self.CtrlOn==True:
                    if (keyboard=="c") or (keyboard=="C"):
                        linetext.copy()
                    elif keyboard=="x" or keyboard=="X":
                        linetext.cut()
                    elif keyboard=="v" or keyboard=="V":
                        linetext.paste()
                    self.CtrlOn=False
                else :
                    if (self.CapsOn==True) :
                        linetext.setText(linetext.text()+self.buttons2[index])
                    else :
                        linetext.setText(linetext.text()+self.buttons[index])
                    if self.ShiftOn :
                        self.ShiftOn=not self.ShiftOn
                        self.CapsOn=not self.CapsOn
                        self.RedrawKeyboard()
        #print(self.buttons[index])
        #print(str(index))
    
    def RedrawKeyboard(self):        
        for x in range(len(self.buttons)) :
            #btn=self.btn[x]
            if (self.CapsOn==True) :
                txtKey=self.buttons2[x]
            else :
                txtKey=self.buttons[x]
            self.btn[x].setText(txtKey)
            
    def RedrawPayment(self):
        for y in range(6):
            if y > len(self.ModePay)-1:
                self.btnPay[y].hide()
            else:
                self.btnPay[y].setText(self.ModePay[y])
                #print(self.ModePay[y])
                if len(self.ModePay)>3:
                    if len(self.ModePay)%2==0:
                        self.btnPay[y].setGeometry(QtCore.QRect((2+y//2*512), (2+y%2*150), 508, 146))
                    else :
                        self.btnPay[y].setGeometry(QtCore.QRect((2+y//3*512), (2+y%3*100), 508, 106))
                else :
                    if len(self.ModePay)%2==0:
                        self.btnPay[y].setGeometry(QtCore.QRect(2, (2+y%2*150), 1020, 146))
                    else :
                        self.btnPay[y].setGeometry(QtCore.QRect(2, (2+y%3*(300//len(self.ModePay))), 1020, 300//len(self.ModePay)-4))                
                self.btnPay[y].show()
                        
                #self.btnPay[y].setGeometry(QtCore.QRect((2+y//3*512), (2+y%3*120), 508, 116))    
        
    def LogoClicked(self):
        vis = self.frameLogin.isVisible()
        if vis:
            self.frameLogin.hide()
            self.lineUserID.setText("")
            self.linePassword.setText("")
            self.frameKeyboard.hide()
            if self.IsInternetClicked==True:
                self.IsInternetClicked=False
        else :
            self.frameLogin.show()
            self.lineUserID.setFocus()
            self.frameKeyboard.show()
            self.frameLogin.raise_()
            self.frameKeyboard.raise_()
    
    def LoginClicked(self):
        inputuserid=self.lineUserID.text()
        inputuserid=inputuserid.rstrip("\n")
        inputpass=self.linePassword.text()
        inputpass=inputpass.rstrip("\n")
        #if self.lineUserID.text() == self.UserID and self.linePassword.text() == self.Password :
        if inputuserid == self.UserID and inputpass == self.Password :
            self.lineUserID.setText("")
            self.linePassword.setText("")
            self.frameLogin.hide()
            if self.IsInternetClicked==True:
                self.frameKeyboard.hide()  
                self.IsInternetClicked=False
                Dialog.showMinimized()
            else :
                #self.frameSetting.move(820,10)
                self.lineStaff.setText(self.Staff)
                self.lineKode1.setText(self.Kode1)
                self.lineKode2.setText(self.Kode2)
                self.lineKode3.setText(self.Kode3)
                self.lineCaption1.setText(self.Caption1)
                self.lineCaption2.setText(self.Caption2)
                self.lineCaption3.setText(self.Caption3)
                if self.TypePay=="Single":
                    self.GBSingle.setChecked(True)
                else :
                    self.GBMulti.setChecked(True)
                self.lineStaff.setFocus()
                self.frameSetting.show()
        else :
            self.lineUserID.setText("")
            self.linePassword.setText("")
            
    def DailyClicked(self):
        self.StepCount=1
        self.HelpSelected="Daily"
        self.WebStepSelected=self.WebStepDaily
        #self.webHelp.setUrl(QtCore.QUrl(self.WebStepDaily[self.StepCount -1]))
        self.webHelp.setUrl(QtCore.QUrl(self.WebStepSelected[self.StepCount -1]))
        self.webHelp.show()
        self.lblStep.setText("Step - "+ str(self.StepCount))
        self.frameHelp.show()
        self.frameHelp.raise_()
        
    def WeeklyClicked(self):
        self.StepCount=1
        self.HelpSelected="Weekly"
        self.WebStepSelected=self.WebStepWeekly
        #self.webHelp.setUrl(QtCore.QUrl(self.WebStepDaily[self.StepCount -1]))
        self.webHelp.setUrl(QtCore.QUrl(self.WebStepSelected[self.StepCount -1]))
        self.webHelp.show()
        self.lblStep.setText("Step - "+ str(self.StepCount))
        self.frameHelp.show()
        self.frameHelp.raise_()
        
        
    def NextHelpClicked(self):
        print(self.StepCount)
        self.StepCount+=1
        print(self.StepCount)
        if self.StepCount<=len(self.WebStepSelected):
            self.webHelp.setUrl(QtCore.QUrl(self.WebStepSelected[self.StepCount -1]))
            self.lblStep.setText("Step - "+ str(self.StepCount))
            self.NextHelpBtn.setText("Next")
            #if self.StepCount==3:
                #self.NextHelpBtn.setText("Exit")
            #else :
               #self.NextHelpBtn.setText("Next")
        elif self.StepCount==len(self.WebStepSelected)+1:
            self.BackToSettingBtn.hide()
            self.NextStepBtn2.show()
            self.frameIngredientSetting.show()
            self.frameIngredientSetting.raise_()
        elif self.StepCount==len(self.WebStepSelected)+2:
            self.lblStep.setText("Step - "+ str(self.StepCount))
            self.webHelp.hide()
            self.lblTimerCD.show()
            self.NextHelpBtn.hide()
            self.m=600
            self.TimerCD.start()
        else :
            self.frameHelp.hide()
            self.CancelSettingClicked()
            
    def TimerCDOn(self):
        self.m-=1
        self.lblTimerCD.setText("Mohon tunggu..\n"+str(self.m//60).zfill(2)+":"+str(self.m%60).zfill(2))
        if self.m==0:
            self.lblTimerCD.setText("Selesai.\n"+str(self.m//60).zfill(2)+":"+str(self.m%60).zfill(2))
            self.StepCount+=1
            self.NextHelpBtn.show()
            self.NextHelpBtn.setText("Finish")
            self.TimerCD.stop()
            
    def TimerAutoBackOn(self):
        self.o+=1
        if self.o==15:
            self.frameInformation.hide()
            self.frameInformation2.hide()
            self.framePayment.hide()
            self.framePayment2.hide()
            self.frameSinglePayment.hide()
            self.webView.hide()
            self.frameMenu.show()
            self.lblMenuSelected.setText("Pilihan Rasa")
            self.OrderQty = 1
            self.lblQty.setText("1")
            self.lblMenuSelected.hide()
            self.lblMenuPrice.hide()
            self.lblMainTitle.show()
            self.o=0
            self.TimerAutoBack.stop()
            
        
    def SaveSettingClicked(self):
        #if self.fileExist :
            #os.remove("/home/pi/Documents/OmegaCoffee/Setting.txt")
        #print(self.fileSettingBackup)
        settingFile = open(self.fileSettingBackup, "w+") 
        settingFile.write("Staff : "+self.lineStaff.text()+"\n")
        settingFile.write("Kode1 : "+self.lineKode1.text()+"\n")
        settingFile.write("Caption1 : "+self.lineCaption1.text()+"\n")
        settingFile.write("Kode2 : "+self.lineKode2.text()+"\n")
        settingFile.write("Caption2 : "+self.lineCaption2.text()+"\n")
        settingFile.write("Kode3 : "+self.lineKode3.text()+"\n")
        settingFile.write("Caption3 : "+self.lineCaption3.text()+"\n")
        if self.GBSingle.isChecked() :
            settingFile.write("TypePay : Single")
            self.TypePay="Single"
        elif self.GBMulti.isChecked() :
            settingFile.write("TypePay : Multi")
            self.TypePay="Multi"        
        
        settingFile = open(self.fileSetting, "w+") 
        settingFile.write("Staff : "+self.lineStaff.text()+"\n")
        settingFile.write("Kode1 : "+self.lineKode1.text()+"\n")
        settingFile.write("Caption1 : "+self.lineCaption1.text()+"\n")
        settingFile.write("Kode2 : "+self.lineKode2.text()+"\n")
        settingFile.write("Caption2 : "+self.lineCaption2.text()+"\n")
        settingFile.write("Kode3 : "+self.lineKode3.text()+"\n")
        settingFile.write("Caption3 : "+self.lineCaption3.text()+"\n")
        if self.GBSingle.isChecked() :
            settingFile.write("TypePay : Single")
            self.TypePay="Single"
        elif self.GBMulti.isChecked() :
            settingFile.write("TypePay : Multi")
            self.TypePay="Multi"
        #shutil.copy(self.fileSettingBackup, self.fileSetting)
        #if CheckFile(self.fileSetting):
            #os.remove(self.fileSetting)
        #shutil.copy(self.fileSettingBackup, self.fileSetting)
        
        self.Staff = self.lineStaff.text()
        self.Staff = self.Staff.rstrip("\r\n")
        self.Kode1 = self.lineKode1.text()
        self.Kode1 = self.Kode1.rstrip("\r\n")
        self.Kode2 = self.lineKode2.text()
        self.Kode2 = self.Kode2.rstrip("\r\n")
        self.Kode3 = self.lineKode3.text()
        self.Kode3 = self.Kode3.rstrip("\r\n")
        self.Caption1 = self.lineCaption1.text()
        self.Caption1 = self.Caption1.rstrip("\r\n")
        self.Caption2 = self.lineCaption2.text()
        self.Caption2 = self.Caption2.rstrip("\r\n")
        self.Caption3 = self.lineCaption3.text()
        self.Caption3 = self.Caption3.rstrip("\r\n")
        if len(self.Caption1)>15 :
            self.Menu1Btn.setText(self.Caption1[:15]+"...")
        else :
            self.Menu1Btn.setText(self.Caption1)
        if len(self.Caption2)>15 :
            self.Menu2Btn.setText(self.Caption2[:15]+"...")
        else :
            self.Menu2Btn.setText(self.Caption2)
        if len(self.Caption3)>15 :
            self.Menu3Btn.setText(self.Caption3[:15]+"...")
        else :
            self.Menu3Btn.setText(self.Caption3)
        self.frameSetting.hide() 
        self.frameKeyboard.hide()
            
    def CancelSettingClicked(self):
        vis = self.frameSetting.isVisible()
        if vis :
            self.frameSetting.hide()
            self.lineStaff.setText("")
            self.lineKode1.setText("")
            self.lineKode2.setText("")
            self.lineKode3.setText("")
            self.lineCaption1.setText("")
            self.lineCaption2.setText("")
            self.lineCaption3.setText("")
            self.frameKeyboard.hide()
            
    def IngredientSettingClicked(self):
        self.BackToSettingBtn.show()
        self.frameIngredientSetting.show()
        self.frameIngredientSetting.raise_()
        
    def BackClicked(self):
        self.frameIngredientSetting.hide()
        
    def NextStepBtn2Clicked(self):
        self.NextHelpClicked()
        self.frameIngredientSetting.hide()
            
    def MenuClick(self):
        #self.CekPayment()
        #self.framePayment.show()
        #self.frameProgress.show()
        #self.lblInfoProgress.setText("Get Mode Payment. Please Wait..")
        self.MenuSelected=self.Kode1
        #print(self.MenuSelected)
        #self.CekStoknStaff()
        #self.lblMenuSelected.setText(str(self.OrderQty)+" pcs "+self.Caption1)
        #if len(self.Caption1)>15 :
            #self.lblMenuSelected.setText(str(self.OrderQty)+" pcs "+self.Caption1[:15]+"...")
        #else :
            #self.lblMenuSelected.setText(str(self.OrderQty)+" pcs "+self.Caption1)
        self.l=0
        self.TimerProgress.start()
        
    def Menu2Click(self):
        #self.CekPayment()
        #self.framePayment.show()
        #self.frameProgress.show()
        #self.lblInfoProgress.setText("Get Mode Payment. Please Wait..")
        self.MenuSelected=self.Kode2
        #print(self.MenuSelected)
        #self.CekStoknStaff()
        #self.lblMenuSelected.setText(str(self.OrderQty)+" pcs "+self.Caption2)
        #if len(self.Caption2)>15 :
            #self.lblMenuSelected.setText(str(self.OrderQty)+" pcs "+self.Caption2[:15]+"...")
        #else :
            #self.lblMenuSelected.setText(str(self.OrderQty)+" pcs "+self.Caption2)
        self.l=0
        self.TimerProgress.start()
        
    def Menu3Click(self):
        #self.CekPayment()
        #self.framePayment.show()
        #self.frameProgress.show()
        #self.lblInfoProgress.setText("Get Mode Payment. Please Wait..")
        self.MenuSelected=self.Kode3
        #print(self.MenuSelected)
        #self.CekStoknStaff()
        #self.lblMenuSelected.setText(str(self.OrderQty)+" pcs "+self.Caption3)
        #if len(self.Caption3)>15 :
            #self.lblMenuSelected.setText(str(self.OrderQty)+" pcs "+self.Caption3[:15]+"...")
        #else :
            #self.lblMenuSelected.setText(str(self.OrderQty)+" pcs "+self.Caption3)
        self.l=0
        self.TimerProgress.start()
        
    def CekStoknStaff(self):
        hasilcek, cekharga, ceksatuan=Api.CekStoknStaff(self.Staff, self.MenuSelected, self.OrderQty)
        #try:
        #    print("cabang "+self.Staff[0:8]+" staff "+self.Staff+" qty "+str(self.OrderQty))
        #    r=requests.post("http://api-prod.omegasoft.co.id/v1/payment/iot-omega/check_stock", data={"token":"9eeb7e2b9e5c48308256224e6d97a02f", "UID":"MkENhq8H36VFtJpjByuIaoSmR49nTUOv", "kode_barang":self.MenuSelected, "ingredient":"1", "qty":self.OrderQty, "cabang":self.Staff[0:8], "ispos":"1", "kode_staff":self.Staff})
        #    print(r.text)
            #print(data)
        #    result=json.loads(r.text)
        #    if result.get("error")=="true":
        #        if result.get("keterangan")=="Stok kurang dari Stok Limit":
        #            hasilcek="Error Stok"
                    #return "Error Stok"
        #       else :
        #            hasilcek="Error Staff"
                    #return "Error Staff"
        #        cekharga="0"
        #       ceksatuan="Error"
        #    else :
                #return "Sukses"
        #        hasilcek="Sukses"
        #        cekharga=result.get("harga")
        #        ceksatuan=result.get("satuan")
        #except Exception as e :
        #    hasilcek="Terjadi Kesalahan"
        #    cekharga="Terjadi Kesalahan"
        #    ceksatuan="Terjadi Kesalahan"
        print("Hasil cek : "+hasilcek)
        print("Harga : "+cekharga+" satuan "+ceksatuan)
        if hasilcek=="Sukses":
            #self.CekPayment()
            print(self.MenuSelected)
            if self.MenuSelected==self.Kode1 :
                txtCaption=self.Caption1
            elif self.MenuSelected==self.Kode2 :
                txtCaption=self.Caption2
            elif self.MenuSelected==self.Kode3 :
                txtCaption=self.Caption3
            if len(txtCaption)>15 :
                self.lblMenuSelected.setText(str(self.OrderQty)+" "+ceksatuan+" "+txtCaption[:15]+"...")
            else :
                self.lblMenuSelected.setText(str(self.OrderQty)+" "+ceksatuan+" "+txtCaption)                
            totalharga=int(self.OrderQty)*int(cekharga)
            self.lblMenuPrice.setText("Total Rp "+str(totalharga))
            self.lblMenuSelected.show()
            self.lblMenuPrice.show()
            if self.TypePay=="Multi":
                if self.getPaymentMode==True:
                    self.frameProgress.hide()
                    #self.framePayment.show()
                    self.framePayment2.show()
                else :
                    self.CekPayment()
            elif self.TypePay=="Single":
                print(self.IsSingleQR)
                if self.IsSingleQR==False:
                    self.lblInformation.setText("Terjadi kesalahan.\nSilahkan coba lagi")
                    self.frameInformation.show()    
                else:
                    self.TrxId, urlqr = Api.CreatePayment(self.Staff, self.MenuSelected, self.OrderQty, self.PaySelected)
                    print("TrxId : "+self.TrxId + " , url : "+ urlqr)
                    if self.TrxId == "Terjadi Kesalahan" and urlqr == "Terjadi Kesalahan":
                        self.frameProgress.hide()
                        self.lblInformation.setText("Terjadi kesalahan.\nSilahkan coba lagi")
                        self.frameInformation.show()    
                    else :
                        self.frameProgress.hide()
                        self.webSingleQR.setUrl(QtCore.QUrl(urlqr))
                        self.frameSinglePayment.show()
                        self.frameSinglePayment.raise_()
                        cursor=QtGui.QCursor()
                        print(cursor.pos())
                        cursor.setPos(0,0)
                        self.i=0
                        self.payCancel=False
                        self.TimerPay.start()
                #self.frameProgress.hide()                
                #self.frameSinglePayment.show()
        else :
            self.frameProgress.hide()
            if hasilcek=="Error Stok":
                self.lblInformation.setText("Maaf, pilihan Anda tidak tersedia")
            elif hasilcek=="Error Staff":
                self.lblInformation.setText("Staff tidak aktif")
            elif hasilcek=="Terjadi Kesalahan":
                self.lblInformation.setText("Terjadi kesalahan.\nSilahkan coba lagi")
            elif hasilcek=="Timeout":
                self.lblInformation.setText("Timeout")
            #else :
            #    self.lblInformation.setText("Terjadi kesalahan. Silahkan coba lagi")
            self.frameInformation.show()
            
    def CekPayment(self):
        self.LaundroMatBtn.hide()
        self.GoPayBtn.hide()
        self.LinkAjaBtn.hide()
        self.ShopeeBtn.hide()
        hasiltipe=Api.CekTipePayment(self.Staff)
        self.ModePay.clear()
        print("Hasil tipe : "+hasiltipe)
        #if "Laundromat" in hasiltipe:
        #    self.LaundroMatBtn.show()
        if "Terjadi Kesalahan" in hasiltipe:
            self.lblInformation.setText("Terjadi kesalahan.\nSilahkan coba lagi")
            self.frameInformation.show()
        else :
            if "GoPay" in hasiltipe:
                self.GoPayBtn.show()
                self.ModePay.append("GoPay")
            if "LinkAja" in hasiltipe:
                self.LinkAjaBtn.show()
                self.ModePay.append("LinkAja")
            if "Shopee" in hasiltipe:
                #self.ShopeeBtn.show()
                self.ModePay.append("Shopee")
                self.IsSingleQR=True
            self.frameProgress.hide()
            #self.framePayment.show()
            self.RedrawPayment()
            self.framePayment2.show()
    
    def CancelPayment(self):
        vis=self.webView.isVisible()
        vis2=self.frameInformation.isVisible()
        vis3=self.frameQR.isVisible()
        vis4=self.frameSinglePayment.isVisible()
        if vis or vis4 :
            if vis :
                self.CancelPaymentBtn.hide()
                self.CancelPaymentBtn2.hide()
            elif vis4 :
                self.CancelSinglePaymentBtn.hide()
            self.frameProgress.show()
            self.lblInfoProgress.setText("Cancelling.\nPlease Wait..")
            self.payCancel=True
            self.tryCancel=0
            #hasilbatal = Api.CancelPayment(self.TrxId, "")
            #print("Hasil batal : "+hasilbatal)
            #if hasilbatal=="Dibatalkan":
                #self.TrxId=""
                #self.webView.hide()
                #self.TimerPay.stop()
                #self.frameProgress.hide()
                #self.lblInformation.setText("Pembelian dibatalkan")
                #self.frameInformation.show()
            #elif hasilbatal!="Terjadi kesalahan" :
                #self.webView.hide()
                #self.lblInformation.setText(hasilbatal)
                #self.frameInformation.show()
        elif vis2 :
            self.frameMenu.show()
            self.framePayment.hide()
            self.framePayment2.hide()
            self.frameInformation.hide()
            self.lblMenuSelected.setText("Pilihan Rasa")
            self.OrderQty = 1
            self.lblQty.setText("1")
            self.lblMenuSelected.hide()
            self.lblMenuPrice.hide()
            self.lblMainTitle.show()
            self.TimerStatus.stop()
            self.CancelSinglePaymentBtn.show()
            self.CancelPaymentBtn.show()
            self.CancelPaymentBtn2.show()
            self.TimerAutoBack.stop()
        elif vis3 :
            self.frameProgress.show()
            self.lblInfoProgress.setText("Cancelling.\nPlease Wait..")
            self.payCancel=True
            self.tryCancel=0
            self.CancelPaymentBtn.hide()
            #hasilbatal=Api.CancelPayment(self.TrxId, "Laundromat")
            #print("Hasil batal : "+hasilbatal)
            #if hasilbatal=="Dibatalkan":
                #self.TrxId=""
                #self.frameQR.hide()
                #self.TimerPay.stop()
                #self.frameProgress.hide()
                #self.lblInformation.setText("Pembelian dibatalkan")
                #self.frameInformation.show()
            #elif hasilbatal!="Terjadi kesalahan" :
                #self.frameQR.hide()
                #self.lblInformation.setText(hasilbatal)
                #self.frameInformation.show()
        else :
            self.frameMenu.show()
            self.framePayment.hide()
            self.framePayment2.hide()
            self.frameSinglePayment.hide()
            self.webView.hide()
            self.frameInformation.hide()
            self.lblMenuSelected.setText("Pilihan Rasa")
            self.OrderQty = 1
            self.lblQty.setText("1")
            self.lblMenuSelected.hide()
            self.lblMenuPrice.hide()
            self.lblMainTitle.show()
            self.CancelSinglePaymentBtn.show()
            self.CancelPaymentBtn.show()
            self.CancelPaymentBtn2.show()
            self.TimerAutoBack.stop()
            
    def LinkAjaClicked(self):
        self.PaySelected="LinkAja"
        self.l=0
        self.TimerProgress.start()
        #self.frameProgress.show()
        #self.lblInfoProgress.setText("Get QR Code. Please Wait..")
        #self.TrxId, urlqr = Api.CreatePayment(self.Staff, self.MenuSelected, self.OrderQty, "LinkAja")
        #print("TrxId : "+self.TrxId + " , url : "+ urlqr)
        #if self.TrxId == "Terjadi Kesalahan" and urlqr == "Terjadi Kesalahan":
            #self.frameProgress.hide()
            #self.lblInformation.setText("Terjadi kesalahan. Silahkan coba lagi")
            #self.frameInformation.show()    
        #else :
            #self.frameProgress.hide()
            #self.webView.setUrl(QtCore.QUrl(urlqr))
            #self.webView.show()
            #self.i=0
            #self.TimerPay.start()
    
    def ModePayClicked(self, index):
        print(self.btnPay[index].text())
        self.PaySelected=self.btnPay[index].text()
        self.l=0
        self.TimerProgress.start()
            
    def GoPayClicked(self):
        self.PaySelected="GoPay"
        self.l=0
        self.TimerProgress.start()
        #self.frameProgress.show()
        #self.lblInfoProgress.setText("Get QR Code. Please Wait..")
        #self.TrxId, urlqr = Api.CreatePayment(self.Staff, self.MenuSelected, self.OrderQty, "GoPay")
        #print("TrxId : "+self.TrxId + " , url : "+ urlqr)
        #if self.TrxId == "Terjadi Kesalahan" and urlqr == "Terjadi Kesalahan":
            #self.frameProgress.hide()
            #self.lblInformation.setText("Terjadi kesalahan. Silahkan coba lagi")
            #self.frameInformation.show()
        #else :
            #self.frameProgress.hide()
            #self.webView.setUrl(QtCore.QUrl(urlqr))
            #self.webView.show()
            #self.i=0
            #self.TimerPay.start()
        
    def ShopeeClicked(self):
        self.PaySelected="Shopee"
        self.l=0
        self.TimerProgress.start()
    
    def TimerPayOn(self):
        vis = self.webView.isVisible()
        vis2 = self.frameQR.isVisible()
        vis3 = self.frameSinglePayment.isVisible()
        if self.payCancel :
            print("Cancel ",self.tryCancel)
            if vis or vis3 :
                if vis :
                    hasilbatal = Api.CancelPayment(self.TrxId, "")
                elif vis3 :
                    hasilbatal = Api.CancelPayment(self.TrxId, "Shopee")
                print("Hasil batal : "+hasilbatal)
                if hasilbatal=="Dibatalkan":
                    self.TrxId=""
                    self.webView.hide()
                    self.frameSinglePayment.hide()
                    self.TimerPay.stop()
                    self.frameProgress.hide()
                    self.payCancel=False
                    self.lblInformation.setText("Pembelian dibatalkan.")
                    self.frameInformation.show()
                    self.TimerAutoBack.start()
                else:
                    if self.tryCancel==3:
                        self.TrxId=""
                        self.webView.hide()
                        self.frameSinglePayment.hide()
                        self.TimerPay.stop()
                        self.frameProgress.hide()
                        self.payCancel=False
                        self.lblInformation.setText("Pembelian dibatalkan")
                        self.frameInformation.show()
                        self.TimerAutoBack.start()
                self.tryCancel+=1
            elif vis2 :
                hasilbatal=Api.CancelPayment(self.TrxId, "Laundromat")
                print("Hasil batal : "+hasilbatal)
                if hasilbatal=="Dibatalkan":
                    self.TrxId=""
                    self.frameQR.hide()
                    self.TimerPay.stop()
                    self.frameProgress.hide()
                    self.payCancel=False
                    self.lblInformation.setText("Pembelian dibatalkan.")
                    self.frameInformation.show()
                    self.TimerAutoBack.start()
                else:
                    if self.tryCancel==3:
                        self.TrxId=""
                        self.webView.hide()
                        self.TimerPay.stop()
                        self.frameProgress.hide()
                        self.payCancel=False
                        self.lblInformation.setText("Pembelian dibatalkan.")
                        self.frameInformation.show()
                        self.TimerAutoBack.start()
                self.tryCancel+=1 
        if self.i % 2 == 0 :
            print("Menunggu pembayaran ",self.i, " "+self.TrxId)
            if vis :
                hasilcekstatus=Api.CekPayment(self.TrxId, "")
            elif vis2 :
                hasilcekstatus=Api.CekPayment(self.TrxId, "Laundromat")
            elif vis3 :
                hasilcekstatus=Api.CekPayment(self.TrxId, "Shopee")
            print(hasilcekstatus)
            if hasilcekstatus=="Terbayar":
                self.webView.hide()
                self.frameQR.hide()
                self.frameSinglePayment.hide()
                self.TrxId=""
                self.framePayment.hide()
                self.TimerPay.stop()
                print(self.OrderQty)
                if self.OrderQty==1 :
                    txtLabel1="Pembelian berhasil."
                    txtLabel2="Mohon tunggu.."
                    self.lblInformation.setText("<span style='font-size:30pt'>"+txtLabel1+"</span><br><span style='font-size:50pt'>"+txtLabel2+"</span>")
                    #self.lblInformation.setText("Pembelian berhasil.")
                    self.frameInformation.show()
                    self.BackToMainBtn.hide()
                    self.j=0
                    self.TimerStatus.start()
                else :
                    self.OrderQty=self.OrderQty -1
                    if self.OrderQty==0:
                        txtLabel1="Pembelian berhasil."
                        txtLabel2="Mohon tunggu.."
                        self.lblInformation2.setText("<span style='font-size:30pt'>"+txtLabel1+"</span><br><span style='font-size:50pt'>"+txtLabel2+"</span>")
                        #self.lblInformation2.setText("Pembelian berhasil.\nMohon tunggu..")
                        #self.lblInformation2.setText("Semua cup sudah diambil")
                        self.NextCupBtn.setText("Kembali ke Pilihan Rasa")
                        self.NextCupBtn.hide()
                    else :
                        txtLabel1="Pembelian berhasil."
                        txtLabel2="Mohon tunggu.."
                        self.lblInformation2.setText("<span style='font-size:30pt'>"+txtLabel1+"</span><br><span style='font-size:50pt'>"+txtLabel2+"</span>")
                        #self.lblInformation2.setText("Pembelian berhasil.\nMohon tunggu..")
                        self.NextCupBtn.setText("Cup Berikutnya")
                        self.NextCupBtn.hide()
                        #self.lblInformation2.setText("Pembelian berhasil. Sisa cup : "+ str(self.OrderQty))
                    self.frameInformation2.show()
                    self.j=0
                    self.TimerStatus.start()
                #self.TimerStatus2()
            elif hasilcekstatus=="Belum":
                if self.i>=180 :
                    if vis or vis2 or vis3 :
                        self.CancelPayment()
                        #self.TrxId=""
                        #self.framePayment.hide()
                        #self.frameQR.hide()
        self.i+=1
    
    def NextCupClicked(self):
        if self.OrderQty>0:
            self.OrderQty=self.OrderQty -1
            if self.OrderQty==0:
                self.NextCupBtn.setText("Kembali ke Pilihan Rasa")
                txtLbl1="Mohon tunggu.."
                self.lblInformation2.setText("<span style='font-size:50pt'>"+txtLbl1+"</span>")
                self.NextCupBtn.hide()
                #self.lblInformation2.setText("Semua cup sudah diambil")
            else :
                txtLbl1="Mohon tunggu.."
                self.lblInformation2.setText("<span style='font-size:50pt'>"+txtLbl1+"</span>")
                #self.lblInformation2.setText("Mohon tunggu..")
                self.NextCupBtn.setText("Cup Berikutnya")
                self.NextCupBtn.hide()
                #self.lblInformation2.setText("Sisa cup yang belum diambil: "+ str(self.OrderQty))
            #self.frameInformation2.show()
            self.j=0
            self.TimerStatus.start()
        else :
            self.frameInformation2.hide()
            self.frameMenu.show()
            self.OrderQty=1
            self.lblQty.setText(str(self.OrderQty))
            self.lblMenuSelected.setText("Pilihan Rasa")
            self.lblMenuSelected.hide()
            self.lblMenuPrice.hide()
            self.lblMainTitle.show()
            self.TimerStatus.stop()
               
    def TimerStatusOn(self):
        if self.j==0:
            ConnectRelay(self.channel1)
            print("Masukkan uang")
            #time.sleep(1)
            #DisconnectRelay(self.channel1)
        elif self.j==1:
            DisconnectRelay(self.channel1)
            print("Selesai masukkan uang")
        elif self.j==2:
            if self.MenuSelected==self.Kode1:
                ConnectRelay(self.channel2)
                print("tekan menu1")
            elif self.MenuSelected==self.Kode2:
                ConnectRelay(self.channel3)
                print("tekan menu2")
            elif self.MenuSelected==self.Kode3:
                ConnectRelay(self.channel4)
                print("tekan menu3")
            #time.sleep(5)
        elif self.j==1000:
            if self.MenuSelected==self.Kode1:
                DisconnectRelay(self.channel2)
            elif self.MenuSelected==self.Kode2:
                DisconnectRelay(self.channel3)
            elif self.MenuSelected==self.Kode3:
                DisconnectRelay(self.channel4)
            #self.MenuSelected=""
        elif self.j==3000:      
            vis = self.frameInformation.isVisible()
            vis2 = self.frameInformation2.isVisible()
            if vis :
                txtLabel1="Silahkan ambil cup."
                txtLabel2="Terimakasih."
                self.lblInformation.setText("<span style='font-size:30pt'>"+txtLabel1+"</span><br><span style='font-size:50pt'>"+txtLabel2+"</span>")
                #self.lblInformation.setText("Silahkan ambil cup.\nTerimakasih.")
                self.BackToMainBtn.show()
            elif vis2 :
                if self.OrderQty == 0 :
                    txtLabel1="Semua cup sudah diambil."
                    txtLabel2="Terimakasih."
                    self.lblInformation2.setText("<span style='font-size:30pt'>"+txtLabel1+"</span><br><span style='font-size:50pt'>"+txtLabel2+"</span>")
                    #self.lblInformation2.setText("Semua cup sudah diambil.\nTerimakasih.")
                else :
                    txtLabel1="Sisa cup : "+ str(self.OrderQty)
                    #txtLabel2="Silahkan ambil Cup lalu tekan Cup Berikutnya."
                    txtLabel2="Silahkan ambil Cup"
                    txtLabel3="Lalu tekan Cup Berikutnya"
                    self.lblInformation2.setText("<span style='font-size:30pt'>"+txtLabel1+"</span><br><span style='font-size:50pt'>"+txtLabel2+"</span><br><span style='font-size:50pt'>"+txtLabel3+"</span>")
                    #self.lblInformation2.setText("Sisa cup : "+ str(self.OrderQty)+". \nSilahkan ambil Cup lalu tekan Cup Berikutnya.")
                    self.TimerStatus.stop()
                self.NextCupBtn.show()
            #self.TimerStatus.stop()
        elif self.j==6000:      
            vis = self.frameInformation.isVisible()
            vis2 = self.frameInformation2.isVisible()
            if vis :
                self.frameInformation.hide()
            elif vis2:
                self.frameInformation2.hide()
            self.frameMenu.show()
            self.framePayment.hide()
            self.webView.hide()
            self.frameInformation.hide()
            self.lblMenuSelected.setText("Pilihan Rasa")
            self.OrderQty = 1
            self.lblQty.setText("1")
            self.lblMenuSelected.hide()
            self.lblMenuPrice.hide()
            self.lblMainTitle.show()
            self.TimerStatus.stop()
        self.j+=1
        
    def TimerStatusOctOn(self):
        if self.j==0:
            ConnectRelay(self.channel5)
            print("Masukkan uang")
            #time.sleep(1)
            #DisconnectRelay(self.channel1)
        elif self.j==1:
            DisconnectRelay(self.channel5)
            print("Selesai masukkan uang")
        elif self.j==2:
            if self.MenuSelected==self.Kode1:
                ConnectRelay(self.channel2)
                print("tekan menu1")
            elif self.MenuSelected==self.Kode2:
                ConnectRelay(self.channel3)
                print("tekan menu2")
            elif self.MenuSelected==self.Kode3:
                ConnectRelay(self.channel4)
                print("tekan menu3")
            time.sleep(5)
        elif self.j==5:
            if self.MenuSelected==self.Kode1:
                DisconnectRelay(self.channel2)
            elif self.MenuSelected==self.Kode2:
                DisconnectRelay(self.channel3)
            elif self.MenuSelected==self.Kode3:
                DisconnectRelay(self.channel4)
            #self.MenuSelected=""
            time.sleep(3)
        elif self.j==2000:      
            vis = self.frameInformation.isVisible()
            vis2 = self.frameInformation2.isVisible()
            if vis :
                txtLabel1="Silahkan ambil cup."
                txtLabel2="Terimakasih."
                self.lblInformation.setText("<span style='font-size:30pt'>"+txtLabel1+"</span><br><span style='font-size:50pt'>"+txtLabel2+"</span>")
                #self.lblInformation.setText("Silahkan ambil cup.\nTerimakasih.")
                self.BackToMainBtn.show()
            elif vis2 :
                if self.OrderQty == 0 :
                    txtLabel1="Semua cup sudah diambil."
                    txtLabel2="Terimakasih."
                    self.lblInformation2.setText("<span style='font-size:30pt'>"+txtLabel1+"</span><br><span style='font-size:50pt'>"+txtLabel2+"</span>")
                    #self.lblInformation2.setText("Semua cup sudah diambil.\nTerimakasih.")
                else :
                    txtLabel1="Sisa cup : "+ str(self.OrderQty)
                    #txtLabel2="Silahkan ambil Cup lalu tekan Cup Berikutnya."
                    txtLabel2="Silahkan ambil Cup"
                    txtLabel3="Lalu tekan Cup Berikutnya"
                    #self.lblInformation2.setText("<span style='font-size:30pt'>"+txtLabel1+"</span><br><span style='font-size:50pt'>"+txtLabel2+"</span>")
                    self.lblInformation2.setText("<span style='font-size:30pt'>"+txtLabel1+"</span><br><span style='font-size:50pt'>"+txtLabel2+"</span><br><span style='font-size:50pt'>"+txtLabel3+"</span>")
                    #self.lblInformation2.setText("Sisa cup : "+ str(self.OrderQty)+". \nSilahkan ambil Cup lalu tekan Cup Berikutnya.")
                self.NextCupBtn.show()
            self.TimerStatus.stop()
        self.j+=1 
        
    def LaundroMatClicked(self):        
        #img=pyqrcode.create("Testing laundromat qr")
        #img.svg('code.svg', scale=8)
        #self.lblQR.setPixmap(QtGui.QPixmap("./code.svg"))
        #self.frameQR.show()
        print("Laundromat")
        self.TrxId, urlqr = Api.CreatePayment(self.Staff, self.MenuSelected, self.OrderQty, "Laundromat")
        print("TrxId : "+self.TrxId + " , url : "+ urlqr)
        if self.TrxId != "Terjadi Kesalahan" and urlqr != "Terjadi Kesalahan":
            img=pyqrcode.create(self.TrxId)
            img.svg('qrcodelm.svg', scale=5)
            self.lblQR.setPixmap(QtGui.QPixmap("./qrcodelm.svg"))
            self.frameQR.show()
            self.i=0
            self.TimerPay.start()
    
    def WebView(self):
        self.webView.show()
        
    def AddQtyClicked(self):
        self.OrderQty=int(self.lblQty.text())
        if self.OrderQty<10 :
            self.OrderQty+=1
            self.lblQty.setText(str(self.OrderQty))
    
    def DecQtyClicked(self):
        self.OrderQty=int(self.lblQty.text())
        if self.OrderQty>1 :
            self.OrderQty-=1
            self.lblQty.setText(str(self.OrderQty))
    
            
    def retranslateUi(self, Dialog):
        _translate = QtCore.QCoreApplication.translate
        Dialog.setWindowTitle(_translate("Dialog", "Dialog"))
        Dialog.setWindowTitle(_translate("Dialog", "OmegaCoffee"))
        #self.LogoBtn.setText(_translate("Dialog", "LOGO"))
        if len(self.Caption1)>15 :
            self.Menu1Btn.setText(_translate("Dialog", self.Caption1[:15]+"..."))
        else :
            self.Menu1Btn.setText(_translate("Dialog", self.Caption1))
        if len(self.Caption2)>15 :
            self.Menu2Btn.setText(_translate("Dialog", self.Caption2[:15]+"..."))
        else :
            self.Menu2Btn.setText(_translate("Dialog", self.Caption2))
        if len(self.Caption3)>15 :
            self.Menu3Btn.setText(_translate("Dialog", self.Caption3[:15]+"..."))
        else :
            self.Menu3Btn.setText(_translate("Dialog", self.Caption3))
        #self.Menu1Btn.setText(_translate("Dialog", self.Caption1))
        #self.Menu2Btn.setText(_translate("Dialog", self.Caption2))
        #self.Menu3Btn.setText(_translate("Dialog", self.Caption3))
        self.lblUserID.setText(_translate("Dialog", "User"))
        self.lblPassword.setText(_translate("Dialog", "Password"))
        self.CancelLoginBtn.setText(_translate("Dialog", "Cancel"))
        self.LoginBtn.setText(_translate("Dialog", "Login"))
        self.lblStaff.setText(_translate("Dialog", "Staff"))
        self.lblMenu1.setText(_translate("Dialog", "Menu 1"))
        self.lblMenu2.setText(_translate("Dialog", "Menu 2"))
        self.lblMenu3.setText(_translate("Dialog", "Menu 3"))
        self.ResetIngredientBtn.setText(_translate("Dialog", "Ingredient"))
        self.CancelSaveBtn.setText(_translate("Dialog", "Cancel"))
        self.SaveBtn.setText(_translate("Dialog", "Save"))
        #self.DailyBtn.setText(_translate("Dialog", "Daily"))
        #self.WeeklyBtn.setText(_translate("Dialog", "Weekly"))
        #self.EmptyBtn.setText(_translate("Dialog", "Empty"))
        self.LaundroMatBtn.setText(_translate("Dialog", "Laundromat Pay"))
        self.GoPayBtn.setText(_translate("Dialog", "GoPay"))
        self.LinkAjaBtn.setText(_translate("Dialog", "LinkAja"))
        self.ShopeeBtn.setText(_translate("Dialog", "Shopee"))
        self.CancelPaymentBtn.setText(_translate("Dialog", "Cancel"))
        self.lblInformation.setText(_translate("Dialog", "Pembayaran Berhasil"))
        self.BackToMainBtn.setText(_translate("Dialog", "Kembali ke Pilihan Rasa"))
        self.lblInformation2.setText(_translate("Dialog", "Sisa Cup : "))
        self.NextCupBtn.setText(_translate("Dialog", "Cup Berikutnya"))
        self.lblInfoProgress.setText(_translate("Dialog", "Harap tunggu..."))
        self.ProgressBackBtn.setText(_translate("Dialog", "Kembali"))
        self.lblMainTitle.setText(_translate("Dialog", "Pilihan Rasa"))
        self.lblMenuSelected.setText(_translate("Dialog", "Pilihan Rasa"))
        self.lblMenuPrice.setText(_translate("Dialog", "Rp ..."))
        self.AddQtyBtn.setText(_translate("Dialog", "+"))
        self.DecQtyBtn.setText(_translate("Dialog", "-"))
        self.lblQty.setText(_translate("Dialog", "1"))
        self.lblStep.setText(_translate("Dialog", "Step - "))
        self.NextHelpBtn.setText(_translate("Dialog", "Next"))
        self.CancelSinglePaymentBtn.setText(_translate("Dialog", "Cancel"))
        self.CancelPaymentBtn2.setText(_translate("Dialog", "Cancel"))


from PyQt5 import QtWebKitWidgets

if __name__ == "__main__":
    import sys
    AutoUpdate.UpdateProgram()
    app = QtWidgets.QApplication(sys.argv)
    Dialog = QtWidgets.QDialog()
    ui = Ui_Dialog()
    ui.setupUi(Dialog)
    Dialog.show()
    sys.exit(app.exec_())

